#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import numpy as np
import matplotlib.colors as mpl_c

vabcb_list = ['#fb8d62', '#f7875e', '#f2815a', '#ee7b57', '#e97553', '#e56f4f',
              '#e0694b', '#dc6248', '#d75c44', '#d35640', '#ce503c', '#ca4a39',
              '#c54435', '#c13e31', '#bc382d', '#b8322a', '#b32c26', '#b22b24',
              '#b63627', '#bb412a', '#bf4b2d', '#c45630', '#c96133', '#cd6b36',
              '#d27639', '#d6803b', '#db8b3e', '#df9641', '#e4a044', '#e9ab47',
              '#edb64a', '#f2c04d', '#f6cb50', '#fbd653', '#fcdb5a', '#fddd65',
              '#fddf6f', '#fde179', '#fde484', '#fde68e', '#fde898', '#feeba2',
              '#feedad', '#feefb7', '#fef1c1', '#fef4cc', '#fef6d6', '#fff8e0',
              '#fffaea', '#fffdf5', '#ffffff', '#f5fefb', '#ecfdf8', '#e2fbf4',
              '#d9faf0', '#cff9ed', '#c6f8e9', '#bcf6e6', '#b3f5e2', '#a9f4de',
              '#a0f3db', '#96f2d7', '#8df0d3', '#83efd0', '#7aeecc', '#70edc8',
              '#67ebc5', '#61e7c1', '#61ddbf', '#62d4bc', '#63cab9', '#64c0b6',
              '#65b6b3', '#66acb1', '#66a2ae', '#6798ab', '#688ea8', '#6984a5',
              '#6a7aa3', '#6b71a0', '#6b679d', '#6c5d9a', '#6d5397', '#6e4995',
              '#6f4a98', '#70509d', '#7156a3', '#715ca9', '#7262ae', '#7368b4',
              '#746fba', '#7575bf', '#767bc5', '#7681cb', '#7787d0', '#788dd6',
              '#7993dc', '#7a99e2', '#7b9fe7', '#7ca6ed', '#7cacf3']
wdiv0_list = ['#760029', '#7b032d', '#800731', '#860b35', '#8b0e39', '#90123d',
              '#951641', '#9b1945', '#a01d49', '#a5204d', '#aa2451', '#af2755',
              '#b52b59', '#ba2e5d', '#bf3261', '#c43665', '#c93969', '#ce3d6d',
              '#d34172', '#d64777', '#d94d7c', '#dc5282', '#df5887', '#e15d8c',
              '#e46391', '#e76896', '#ea6d9a', '#ec739f', '#ef78a4', '#f27da9',
              '#f482ae', '#f787b2', '#fa8db7', '#fc92bc', '#ff97c0', '#fe9ec4',
              '#fea5c8', '#fdabcc', '#fcb2d0', '#fbb8d3', '#fbbfd7', '#fac5da',
              '#f9cbde', '#f9d1e1', '#f8d7e4', '#f8dde8', '#f7e3eb', '#f6e9ee',
              '#f6eff2', '#f5f5f5', '#eaf2f6', '#dfeff7', '#d4ecf8', '#c8e9f8',
              '#bde6f9', '#b1e3fa', '#a4dffb', '#98dcfc', '#8bd9fd', '#7ed5fe',
              '#72d1fe', '#6dcdfa', '#67c9f7', '#61c5f3', '#5bc1ef', '#55bcec',
              '#4fb8e8', '#49b4e4', '#44b0e1', '#3eacdd', '#38a8d9', '#32a3d6',
              '#2c9fd2', '#269bce', '#2097cb', '#1b93c7', '#158ec3', '#0f8abf',
              '#0986bc', '#0382b8', '#007eb4', '#0079af', '#0075ab', '#0071a6',
              '#006da1', '#00699d', '#006599', '#006194', '#005d90', '#00598b',
              '#005587', '#005183', '#004d7e', '#00497a', '#004576', '#004272',
              '#003e6e', '#003a69', '#003665']
wdiv1_list = ['#0017ab', '#061cb0', '#0d20b6', '#1325bb', '#1929c0', '#1e2dc4',
              '#2431c9', '#2935ce', '#2f39d2', '#343dd7', '#3a40db', '#3f44e0',
              '#4548e4', '#4a4ce9', '#4f50ed', '#5453f2', '#5a57f6', '#5f5bfa',
              '#645fff', '#6a63ff', '#7068ff', '#766dff', '#7c72ff', '#8277ff',
              '#877bff', '#8d80ff', '#9384ff', '#9889ff', '#9e8dff', '#a392ff',
              '#a996ff', '#ae9bff', '#b49fff', '#b9a4ff', '#bfa8ff', '#c4adff',
              '#c9b2ff', '#ccb7fe', '#cfbcfd', '#d3c1fc', '#d6c6fc', '#daccfb',
              '#ddd1fa', '#e1d6f9', '#e4dbf9', '#e7e0f8', '#ebe5f7', '#eeebf6',
              '#f2f0f6', '#f5f5f5', '#f6eff2', '#f6e9ee', '#f7e3eb', '#f8dde8',
              '#f8d7e4', '#f9d1e1', '#f9cbde', '#fac5da', '#fbbfd7', '#fbb8d3',
              '#fcb2d0', '#fdabcc', '#fea5c8', '#fe9ec4', '#ff97c0', '#fc92bc',
              '#fa8db7', '#f787b2', '#f482ae', '#f27da9', '#ef78a4', '#ec739f',
              '#ea6d9a', '#e76896', '#e46391', '#e15d8c', '#df5887', '#dc5282',
              '#d94d7c', '#d64777', '#d34172', '#ce3d6d', '#c93969', '#c43665',
              '#bf3261', '#ba2e5d', '#b52b59', '#af2755', '#aa2451', '#a5204d',
              '#a01d49', '#9b1945', '#951641', '#90123d', '#8b0e39', '#860b35',
              '#800731', '#7b032d', '#760029']
wdiv2_list = ['#870000', '#8d0201', '#930303', '#990504', '#9f0606', '#a50807',
              '#ab0a09', '#b10b0a', '#b70d0c', '#bd0f0d', '#c3100f', '#ca1211',
              '#d01412', '#d61514', '#dd1715', '#e31917', '#ea1b19', '#ed2721',
              '#ef3229', '#f13b30', '#f34436', '#f44d3c', '#f65442', '#f75c47',
              '#f8634c', '#fa6951', '#fb7056', '#fc765a', '#fe7d5f', '#ff8363',
              '#ff896b', '#fe9073', '#fd977c', '#fd9d84', '#fca38c', '#fca993',
              '#fbaf9b', '#fbb4a2', '#fabaa9', '#fac0b1', '#f9c5b8', '#f9cbbf',
              '#f8d0c6', '#f8d6cd', '#f7dbd3', '#f7e0da', '#f6e5e1', '#f6ebe8',
              '#f5f0ee', '#f5f5f5', '#e9f2f6', '#ddf0f7', '#d0edf8', '#c3eaf8',
              '#b6e7f9', '#a8e4fa', '#9ae1fb', '#8cdefc', '#7ddbfd', '#6dd7fe',
              '#62d3fd', '#5dcff9', '#58cbf4', '#53c7f0', '#4ec2ec', '#49bee8',
              '#43bae3', '#3eb6df', '#39b2db', '#34add7', '#2fa9d3', '#2aa5ce',
              '#25a1ca', '#209dc6', '#1b98c2', '#1594be', '#1090ba', '#0b8cb5',
              '#0688b1', '#0183ad', '#007fa9', '#007ba4', '#0077a0', '#00739b',
              '#006f97', '#006b93', '#00678e', '#00638a', '#005f86', '#005b81',
              '#00577d', '#005379', '#004f75', '#004b71', '#00476d', '#004369',
              '#003f65', '#003c61', '#00385d']
wdiv3_list = ['#fe9e74', '#fea076', '#fea178', '#ffa37a', '#ffa47c', '#ffa67e',
              '#ffa780', '#ffa983', '#ffaa85', '#ffac87', '#ffad89', '#ffaf8b',
              '#ffb08d', '#ffb28f', '#ffb391', '#ffb593', '#ffb796', '#ffb898',
              '#ffba9a', '#ffbb9c', '#ffbd9e', '#ffbea0', '#ffc0a2', '#ffc1a4',
              '#ffc3a7', '#ffc4a9', '#ffc6ab', '#ffc7ad', '#ffc9af', '#ffcab1',
              '#ffccb4', '#ffcdb6', '#ffcfb8', '#ffd0ba', '#ffd2bc', '#ffd3be',
              '#ffd5c1', '#ffd6c3', '#ffd8c5', '#ffd9c7', '#ffdbc9', '#ffdccc',
              '#ffdece', '#ffdfd0', '#ffe1d2', '#ffe2d4', '#ffe4d7', '#ffe5d9',
              '#ffe7db', '#ffe8dd', '#ffeadf', '#ffebe2', '#ffede4', '#ffeee6',
              '#fff0e8', '#fff1eb', '#fff3ed', '#fff4ef', '#fff6f1', '#fff7f4',
              '#fff9f6', '#fffaf8', '#fffcfa', '#fffdfd', '#fdfefe', '#fafdfe',
              '#f8fcfd', '#f6fbfd', '#f3fbfc', '#f1fafc', '#eef9fb', '#ecf8fa',
              '#eaf7fa', '#e7f6f9', '#e5f5f9', '#e2f4f8', '#e0f4f7', '#ddf3f7',
              '#dbf2f6', '#d9f1f6', '#d6f0f5', '#d4eff5', '#d1eef4', '#cfedf3',
              '#ccecf3', '#caecf2', '#c7ebf2', '#c5eaf1', '#c2e9f1', '#c0e8f0',
              '#bde7ef', '#bbe6ef', '#b8e5ee', '#b5e4ee', '#b3e4ed', '#b0e3ed',
              '#aee2ec', '#abe1eb', '#a8e0eb', '#a6dfea', '#a3deea', '#a0dde9',
              '#9ddce8', '#9bdbe8', '#98dbe7', '#95dae7', '#92d9e6', '#8fd8e6',
              '#8cd7e5', '#89d6e4', '#86d5e4', '#83d4e3', '#80d3e3', '#7dd3e2',
              '#7ad2e2', '#77d1e1', '#74d0e0', '#70cfe0', '#6dcedf', '#69cddf',
              '#66ccde', '#62cbde', '#5ecadd', '#5ac9dc', '#56c9dc', '#52c8db',
              '#4ec7db', '#49c6da']
wdiv4_list = ['#bb434f', '#bd4650', '#bf4951', '#c14c52', '#c34f54', '#c55255',
              '#c75556', '#c95858', '#cb5b59', '#cd5e5b', '#cf615c', '#d1645e',
              '#d36760', '#d56961', '#d76c63', '#d86f65', '#da7267', '#dc7569',
              '#dd786b', '#df7b6d', '#e17e6f', '#e28071', '#e48373', '#e68675',
              '#e78977', '#e98c7a', '#ea8f7c', '#eb927e', '#ed9581', '#ee9783',
              '#ef9a86', '#f19d89', '#f2a08b', '#f3a38e', '#f4a691', '#f6a994',
              '#f7ac97', '#f8af9a', '#f9b29d', '#fab4a0', '#fbb7a3', '#fbbaa6',
              '#fcbda9', '#fdc0ad', '#fec3b0', '#fec6b3', '#ffc9b7', '#ffccba',
              '#ffcfbe', '#ffd2c1', '#ffd5c5', '#ffd8c9', '#ffdbcd', '#ffded1',
              '#ffe1d5', '#ffe4d9', '#ffe7dd', '#ffeae1', '#ffede5', '#fff0e9',
              '#fff3ed', '#fff6f2', '#fff9f6', '#fffcfa', '#fafdfe', '#f6fbfd',
              '#f1fafb', '#ecf8fa', '#e8f6f9', '#e3f4f8', '#dff2f6', '#daf1f5',
              '#d6eff4', '#d1edf3', '#cdebf1', '#c8e9f0', '#c4e7ef', '#c0e5ed',
              '#bbe3ec', '#b7e2ea', '#b3e0e9', '#afdee7', '#abdce6', '#a6dae5',
              '#a2d8e3', '#9ed6e2', '#9ad4e0', '#96d2de', '#92d0dd', '#8ecedb',
              '#8accda', '#86cad8', '#82c8d7', '#7fc6d5', '#7bc4d3', '#77c2d2',
              '#73c0d0', '#6fbece', '#6cbccd', '#68bacb', '#64b8c9', '#61b6c7',
              '#5db3c6', '#59b1c4', '#56afc2', '#52adc0', '#4fabbf', '#4ba9bd',
              '#47a7bb', '#44a5b9', '#40a3b7', '#3da1b5', '#3a9fb4', '#369db2',
              '#339ab0', '#2f98ae', '#2c96ac', '#2894aa', '#2592a8', '#2190a6',
              '#1d8ea4', '#1a8ca2', '#1689a0', '#12879e', '#0d859c', '#09839a',
              '#048198', '#007f96']

vabcb = mpl_c.LinearSegmentedColormap.from_list( 'vabcb', vabcb_list )
vabcb_r = mpl_c.LinearSegmentedColormap.from_list( 'vabcb_r', vabcb_list[::-1] )

wdiv0 = mpl_c.LinearSegmentedColormap.from_list( 'wdiv0', wdiv0_list )
wdiv0_r = mpl_c.LinearSegmentedColormap.from_list( 'wdiv0_r', wdiv0_list[::-1] )
wdiv1 = mpl_c.LinearSegmentedColormap.from_list( 'wdiv1', wdiv1_list )
wdiv1_r = mpl_c.LinearSegmentedColormap.from_list( 'wdiv1_r', wdiv1_list[::-1] )
wdiv2 = mpl_c.LinearSegmentedColormap.from_list( 'wdiv2', wdiv2_list )
wdiv2_r = mpl_c.LinearSegmentedColormap.from_list( 'wdiv2_r', wdiv2_list[::-1] )
wdiv3 = mpl_c.LinearSegmentedColormap.from_list( 'wdiv3', wdiv3_list )
wdiv3_r = mpl_c.LinearSegmentedColormap.from_list( 'wdiv3_r', wdiv3_list[::-1] )
wdiv4 = mpl_c.LinearSegmentedColormap.from_list( 'wdiv4', wdiv4_list )
wdiv4_r = mpl_c.LinearSegmentedColormap.from_list( 'wdiv4_r', wdiv4_list[::-1] )

bdiv0_list = \
['#fcdc64', '#fcd664', '#fcd163', '#fbcc62', '#fbc662', '#fac161', '#f8bc5f',
 '#f7b75e', '#f5b25d', '#f4ad5c', '#f2a85a', '#f0a359', '#ed9e57', '#eb9a55',
 '#e89554', '#e69152', '#e38c50', '#e0884e', '#dd834d', '#d97f4b', '#d67b49',
 '#d37747', '#cf7345', '#cb6f43', '#c86b42', '#c46740', '#c0643e', '#bc603c',
 '#b85c3a', '#b35939', '#af5537', '#ab5235', '#a64f33', '#a24c32', '#9d4830',
 '#99452e', '#94422d', '#90402b', '#8b3d29', '#863a28', '#813726', '#7c3525',
 '#783223', '#733022', '#6e2d20', '#692b1f', '#64291d', '#5f271c', '#5a251b',
 '#552319', '#502118', '#4b1f17', '#461d16', '#401b14', '#3b1913', '#361812',
 '#311610', '#2d140e', '#28120c', '#23100a', '#1f0e08', '#1a0b06', '#140704',
 '#0b0302', '#000000', '#060408', '#0c080f', '#110d14', '#151019', '#18131d',
 '#1b1621', '#1e1826', '#211a2a', '#241d2e', '#271f33', '#292237', '#2c243c',
 '#2f2740', '#322944', '#352c49', '#382f4d', '#3b3252', '#3d3556', '#40385b',
 '#433a5f', '#453e64', '#484168', '#4b446d', '#4d4771', '#504a75', '#524d7a',
 '#54517e', '#575482', '#595786', '#5b5b8a', '#5d5e8f', '#606293', '#626697',
 '#64699a', '#666d9e', '#6871a2', '#6974a6', '#6b78a9', '#6d7cad', '#6f80b0',
 '#7084b4', '#7288b7', '#738cba', '#7490bd', '#7694c0', '#7799c2', '#789dc5',
 '#79a1c7', '#7aa6c9', '#7baacb', '#7baecd', '#7cb3cf', '#7db7d0', '#7dbcd1',
 '#7dc1d2', '#7dc5d3', '#7dcad3', '#7dcfd3', '#7dd4d3', '#7cd9d2', '#7bded1',
 '#7ae3cf', '#79e8cd', '#77edca']

bdiv1_list = \
['#fcdc64', '#fcd764', '#fbd163', '#fbcc63', '#fbc663', '#fbc162', '#fabb62',
 '#fab562', '#fab061', '#faaa61', '#f9a461', '#f99e60', '#f99860', '#f8925f',
 '#f88b5f', '#f5875d', '#f2825a', '#ef7e57', '#ec7955', '#e87552', '#e5704f',
 '#e26c4c', '#df684a', '#db6347', '#d85f44', '#d55a41', '#d1563e', '#ce513c',
 '#cb4c39', '#c74836', '#c44333', '#c03e30', '#bd3a2d', '#b9352a', '#b53027',
 '#b22b24', '#ac2923', '#a62821', '#a02720', '#9a251f', '#94241e', '#8e221d',
 '#88211b', '#821f1a', '#7c1e19', '#771d18', '#711b17', '#6b1a16', '#661915',
 '#601713', '#5b1612', '#551511', '#501310', '#4a120f', '#45110e', '#400f0d',
 '#3b0e0c', '#360d0b', '#300c0a', '#2b0a09', '#250908', '#1f0706', '#170505',
 '#0c0303', '#000000', '#060408', '#0c0811', '#110c18', '#160f1e', '#1a1123',
 '#1d1428', '#20162c', '#231830', '#271a35', '#2a1c39', '#2d1f3e', '#312143',
 '#342347', '#38264c', '#3b2851', '#3f2b56', '#422d5b', '#462f5f', '#493264',
 '#4d3469', '#51376e', '#543973', '#583c79', '#5c3e7e', '#604183', '#644488',
 '#67468d', '#6b4993', '#6d4c97', '#6e519b', '#6f55a0', '#6f59a4', '#705ea8',
 '#7162ac', '#7166b0', '#726ab4', '#726fb8', '#7373bc', '#7477c0', '#747bc4',
 '#757fc8', '#7684cc', '#7688d0', '#778cd4', '#7790d8', '#7894dc', '#7999e0',
 '#799de4', '#7aa1e8', '#7aa5ec', '#7baaf0', '#7bafed', '#7ab5e9', '#7abae7',
 '#7abfe4', '#79c5e1', '#79cade', '#79cfdb', '#78d4d8', '#78d9d5', '#78ded2',
 '#78e3d0', '#77e8cd', '#77edca']

bdiv2_list = \
['#7ed9e1', '#7bd6df', '#78d3dc', '#76d0da', '#73cdd7', '#70cad5', '#6ec7d2',
 '#6bc3d0', '#68c0cd', '#65bdcb', '#63bac8', '#60b7c6', '#5db4c4', '#5bb1c1',
 '#58aebf', '#55abbc', '#53a8ba', '#50a5b8', '#4da2b5', '#4b9fb3', '#489cb1',
 '#459aae', '#4497ab', '#4394a8', '#4291a5', '#418ea1', '#418b9e', '#40889b',
 '#3f8597', '#3e8294', '#3e7f91', '#3d7c8d', '#3c798a', '#3b7687', '#3b7384',
 '#3a7080', '#396d7d', '#396a7a', '#386877', '#376574', '#366271', '#365f6d',
 '#355c6a', '#345967', '#345764', '#335461', '#32515e', '#314e5b', '#314c58',
 '#304955', '#2f4652', '#2f434f', '#2e414c', '#2d3e49', '#2d3b46', '#2c3943',
 '#2b3640', '#2b333d', '#2a313a', '#292e37', '#292c34', '#282931', '#27262e',
 '#27242b', '#262128', '#2c2129', '#33222a', '#38222c', '#3e222d', '#43222e',
 '#49232f', '#4e2330', '#532331', '#582332', '#5c2433', '#612433', '#662434',
 '#6b2435', '#6f2536', '#742537', '#792538', '#7d2539', '#82253a', '#86263b',
 '#8b263c', '#90263c', '#94263d', '#99273e', '#9d273f', '#a22740', '#a52a41',
 '#a72d42', '#aa3143', '#ac3444', '#af3745', '#b13a47', '#b43d48', '#b64049',
 '#b9434a', '#bb464b', '#bd494c', '#c04c4d', '#c24f4e', '#c5524f', '#c75550',
 '#c95851', '#cc5b52', '#ce5e53', '#d06154', '#d36455', '#d56756', '#d76a57',
 '#da6c58', '#dc6f59', '#de725a', '#e1755b', '#e3785c', '#e57b5d', '#e87e5e',
 '#ea815f', '#ec8460', '#ef8761', '#f18a62', '#f38c63', '#f68f64', '#f89265',
 '#fa9566', '#fd9867', '#ff9b68']

bdiv2_mhalf_list = \
['#000000', '#060203', '#0b0405', '#100508', '#15070a', '#19080c', '#1c090e',
 '#200b0f', '#230c11', '#260d12', '#290d14', '#2b0e15', '#2e0f16', '#301017',
 '#331119', '#35121a', '#38121b', '#3b131c', '#3d141e', '#40151f', '#421620',
 '#451722', '#481823', '#4a1924', '#4d1926', '#501a27', '#531b28', '#551c29',
 '#581d2b', '#5b1e2c', '#5e1f2e', '#60202f', '#632130', '#662232', '#692333',
 '#6c2434', '#6e2535', '#712636', '#732737', '#762938', '#792a38', '#7b2b39',
 '#7e2d3a', '#812e3b', '#832f3b', '#86313c', '#88323d', '#8b343e', '#8e353e',
 '#91363f', '#933840', '#963941', '#993b42', '#9b3c42', '#9e3d43', '#a13f44',
 '#a44045', '#a64245', '#a94346', '#ac4447', '#af4648', '#b14749', '#b44949',
 '#b74a4a', '#ba4c4b', '#bd4d4c', '#bf4f4d', '#c2504d', '#c5524e', '#c7544f',
 '#c85750', '#ca5951', '#cc5b51', '#ce5d52', '#d06053', '#d26254', '#d36455',
 '#d56755', '#d76956', '#d96b57', '#db6e58', '#dd7058', '#de7259', '#e0745a',
 '#e2775b', '#e4795c', '#e67b5c', '#e87e5d', '#e9805e', '#eb825f', '#ed855f',
 '#ef8760', '#f18961', '#f38b62', '#f48e62', '#f69063', '#f89264', '#fa9565',
 '#fc9766', '#fe9966', '#ff9c68', '#ff9f6d', '#ffa271', '#ffa576', '#ffa87a',
 '#ffab7f', '#ffae83', '#ffb088', '#ffb38c', '#ffb691', '#ffb995', '#ffbc99',
 '#ffbf9d', '#ffc2a2', '#ffc4a6', '#ffc7aa', '#ffcaae', '#ffcdb2', '#ffcfb7',
 '#ffd2bb', '#ffd5bf', '#ffd7c3', '#ffdac7', '#ffddcb', '#ffdfcf', '#ffe2d3',
 '#ffe5d7', '#ffe7db']

bdiv2_half_list = \
['#000000', '#030303', '#060506', '#0a080a', '#0d0b0d', '#100d10', '#120f12',
'#141114', '#161216', '#181418', '#1a161a', '#1c171c', '#1e181e', '#1f1a1f',
'#211b21', '#231d23', '#251e25', '#262026', '#292128', '#2e2129', '#33222a',
'#38222b', '#3d222c', '#41222d', '#45222e', '#4a232f', '#4e232f', '#522330',
'#562331', '#5a2332', '#5e2433', '#622433', '#662434', '#6a2435', '#6e2436',
'#712536', '#752537', '#792538', '#7c2639', '#7f2739', '#82283a', '#852a3b',
'#882b3c', '#8b2c3d', '#8e2d3d', '#912f3e', '#94303f', '#973140', '#9a3341',
'#9d3442', '#a03542', '#a33643', '#a63844', '#a93945', '#ac3a46', '#af3c46',
'#b33d47', '#b53f48', '#b74149', '#b9444a', '#bc464b', '#be494c', '#c04b4c',
'#c24d4d', '#c3504e', '#c5524f', '#c75550', '#c95751', '#cb5a51', '#cd5c52',
'#cf5f53', '#d16154', '#d36355', '#d56656', '#d76856', '#d96b57', '#db6d58',
'#dd6f59', '#df725a', '#e1745b', '#e3775b', '#e4795c', '#e67c5d', '#e87e5e',
'#ea805f', '#ec8360', '#ee8560', '#f08861', '#f28a62', '#f48d63', '#f68f64',
'#f79165', '#f99466', '#fb9666', '#fd9967', '#ff9b68', '#ff9e6b', '#ffa26e',
'#ffa572', '#ffa875', '#ffab78', '#ffaf7b', '#ffb27e', '#ffb581', '#ffb884',
'#ffbb87', '#ffbe8a', '#ffc18d', '#ffc490', '#ffc792', '#ffcb95', '#ffce98',
'#ffd19b', '#ffd39e', '#ffd7a1', '#ffd9a4', '#ffdca6', '#ffdfa9', '#ffe2ac',
'#ffe5af', '#ffe8b2', '#ffebb4', '#ffeeb7', '#fff1ba', '#fff4bd', '#fff7bf',
'#fffac2', '#fffcc5'][::-1]

bdiv2_rhalf_list = \
['#000000', '#030303', '#060506', '#090809', '#0c0a0c', '#0f0d0f', '#120f12',
'#141014', '#161216', '#181418', '#1a151a', '#1b171b', '#1d181d', '#1f191f',
'#201b20', '#221c22', '#241e24', '#261f26', '#272127', '#282229', '#29242c',
'#29262e', '#292830', '#2a2a32', '#2a2c34', '#2b2e36', '#2b3038', '#2c313a',
'#2c333c', '#2c353f', '#2d3741', '#2d3943', '#2e3b45', '#2e3d47', '#2e3f49',
'#2f414b', '#2f434e', '#304550', '#304652', '#304854', '#314a56', '#314c58',
'#324e5b', '#32505d', '#33525f', '#335461', '#345663', '#345865', '#355a68',
'#355c6a', '#365e6c', '#36606e', '#376271', '#376473', '#376675', '#386877',
'#386a79', '#396c7c', '#396e7e', '#3a7080', '#3a7283', '#3b7485', '#3b7687',
'#3c7889', '#3d7a8c', '#3e7d8e', '#3f7f90', '#408192', '#418394', '#428596',
'#438798', '#44899a', '#458b9c', '#468d9e', '#478fa1', '#4891a3', '#4993a5',
'#4a95a7', '#4b98a9', '#4c9aab', '#4d9cad', '#4e9eb0', '#4fa0b2', '#50a2b4',
'#51a4b6', '#52a6b8', '#53a9ba', '#55abbc', '#57adbe', '#59afc0', '#5bb1c1',
'#5db3c3', '#5fb5c5', '#61b7c6', '#62bac8', '#64bcca', '#66becb', '#68c0cd',
'#6ac2cf', '#6cc4d1', '#6ec7d2', '#70c9d4', '#72cbd6', '#74cdd8', '#75cfd9',
'#77d1db', '#79d4dd', '#7bd6de', '#7dd8e0', '#80dae2', '#83dce3', '#86dee5',
'#89e0e7', '#8ce2e8', '#8fe4ea', '#92e6ec', '#95e8ed', '#98eaef', '#9bedf0',
'#9feff2', '#a2f1f4', '#a5f3f5', '#a8f5f7', '#abf7f9', '#aef9fa', '#b1fbfc',
'#b4fdfd', '#b7ffff']

bdiv0 = mpl_c.LinearSegmentedColormap.from_list( 'bdiv0', bdiv0_list )
bdiv0_r = mpl_c.LinearSegmentedColormap.from_list( 'bdiv0_r', bdiv0_list[::-1] )
bdiv1 = mpl_c.LinearSegmentedColormap.from_list( 'bdiv1', bdiv1_list )
bdiv1_r = mpl_c.LinearSegmentedColormap.from_list( 'bdiv1_r', bdiv1_list[::-1] )
bdiv2 = mpl_c.LinearSegmentedColormap.from_list( 'bdiv2', bdiv2_list )
bdiv2_r = mpl_c.LinearSegmentedColormap.from_list( 'bdiv2_r', bdiv2_list[::-1] )
bdiv2_half = mpl_c.LinearSegmentedColormap.from_list( 'bdiv2_half', bdiv2_half_list )
bdiv2_half_r = mpl_c.LinearSegmentedColormap.from_list( 'bdiv2_half_r', bdiv2_half_list[::-1] )
bdiv2_rhalf = mpl_c.LinearSegmentedColormap.from_list( 'bdiv2_rhalf', bdiv2_rhalf_list )
bdiv2_rhalf_r = mpl_c.LinearSegmentedColormap.from_list( 'bdiv2_rhalf_r', bdiv2_rhalf_list[::-1] )
bdiv2_mhalf = mpl_c.LinearSegmentedColormap.from_list( 'bdiv2_mhalf', bdiv2_mhalf_list )
bdiv2_mhalf_r = mpl_c.LinearSegmentedColormap.from_list( 'bdiv2_mhalf_r', bdiv2_mhalf_list[::-1] )

RdBuMod_list = \
['#610524', '#650827', '#690c2a', '#6c0f2d', '#701330', '#731633', '#771a36',
 '#7a1d39', '#7e203b', '#81243e', '#842741', '#882a44', '#8b2e46', '#8e3149',
 '#92344c', '#95374e', '#983b51', '#9c3e54', '#9f4156', '#a24459', '#a5485c',
 '#a94b5e', '#ac4e61', '#af5164', '#b35467', '#b65869', '#b95b6c', '#bc5f70',
 '#bf6273', '#c26576', '#c5697a', '#c86c7d', '#cb7080', '#ce7384', '#d17787',
 '#d47a8b', '#d77e8e', '#da8191', '#dd8495', '#e08898', '#e38b9c', '#e68f9f',
 '#e992a2', '#ec96a6', '#ef99a9', '#f29dad', '#f5a0b0', '#f9a4b4', '#fca8b7',
 '#ffabbb', '#feb0bf', '#feb5c3', '#fdbbc7', '#fcc0cb', '#fcc5cf', '#fbcad3',
 '#facfd7', '#fad4db', '#f9d8de', '#f8dde2', '#f8e2e6', '#f7e7ea', '#f6ecee',
 '#f6f0f1', '#ecf3f3', '#e3f1f1', '#daefef', '#d1edec', '#c7ebea', '#bee9e8',
 '#b4e7e6', '#abe5e3', '#a0e3e1', '#96e1df', '#8cdedc', '#81dcda', '#76dad7',
 '#70d7d4', '#6cd4d1', '#67d0ce', '#63cdca', '#5ecac7', '#5ac7c4', '#56c3c1',
 '#51c0be', '#4dbdbb', '#48bab7', '#44b7b4', '#40b3b1', '#3bb0ae', '#37adab',
 '#32aaa8', '#2ea7a4', '#29a3a1', '#25a09e', '#219d9b', '#1c9a98', '#189694',
 '#139391', '#0f908e', '#0b8d8b', '#068988', '#028685', '#008381', '#00807e',
 '#007c7b', '#007978', '#007675', '#007372', '#00706e', '#006c6b', '#006968',
 '#006665', '#006362', '#00605f', '#005d5c', '#005a59', '#005756', '#005453',
 '#005150', '#004d4d', '#004b4a', '#004847', '#004545', '#004242', '#003f3f',
 '#003c3c', '#003939']
AquaIndigo_list = \
['#003a2c', '#003d2f', '#004031', '#004334', '#004637', '#00493a', '#004c3d',
 '#004f3f', '#005242', '#005545', '#005948', '#005c4b', '#005f4e', '#006251',
 '#006554', '#006857', '#006c5a', '#006f5d', '#007260', '#007563', '#007966',
 '#007c69', '#007f6c', '#00836f', '#008672', '#028975', '#068c79', '#0a907c',
 '#0e937f', '#129682', '#169a85', '#1a9d89', '#1ea08c', '#22a48f', '#26a792',
 '#2aaa95', '#2eae99', '#32b19c', '#36b49f', '#3ab8a2', '#3ebba5', '#42bea9',
 '#46c2ac', '#4ac5af', '#4ec8b2', '#52ccb5', '#56cfb9', '#5ad2bc', '#5ed6bf',
 '#63d9c2', '#68dcc6', '#74dfca', '#81e1ce', '#8ce3d2', '#98e5d6', '#a3e7da',
 '#aee9dd', '#b9ebe1', '#c3ece4', '#ceeee8', '#d8f0eb', '#e2f2ef', '#ebf3f2',
 '#f5f5f5', '#f5f0f6', '#f5ebf6', '#f5e6f7', '#f4e1f8', '#f4dcf8', '#f4d7f9',
 '#f4d1fa', '#f4ccfb', '#f4c7fb', '#f4c1fc', '#f3bcfd', '#f3b7fe', '#f3b1fe',
 '#f3abff', '#efa8fd', '#eba4fa', '#e7a1f8', '#e49ef6', '#e09af3', '#dc97f1',
 '#d993ef', '#d590ec', '#d18cea', '#cd89e8', '#ca85e6', '#c682e3', '#c27fe1',
 '#bf7bdf', '#bb78dd', '#b774da', '#b471d8', '#b06ed6', '#ac6ad4', '#a967d1',
 '#a564cf', '#a160cd', '#9e5dcb', '#9a5ac8', '#9756c5', '#9453c2', '#9050bf',
 '#8d4dbb', '#8a49b8', '#8746b5', '#8343b2', '#8040ae', '#7d3cab', '#7a39a8',
 '#7636a5', '#7333a1', '#702f9e', '#6c2c9b', '#692998', '#662694', '#632291',
 '#5f1f8e', '#5c1c8a', '#581887', '#551584', '#521180', '#4e0e7d', '#4b0b79',
 '#470776']
NavyOrangeRed_list = \
['#00228d', '#042591', '#092895', '#0d2b98', '#122e9c', '#16319f', '#1b34a3',
 '#1f36a6', '#2339aa', '#273cad', '#2c3fb1', '#3042b4', '#3445b8', '#3847bb',
 '#3c4abf', '#414dc2', '#4550c5', '#4953c9', '#4d56cc', '#5158d0', '#555bd3',
 '#5a5ed7', '#5e61da', '#6264dd', '#6666e1', '#6a6ae3', '#6e6de5', '#7270e6',
 '#7674e7', '#7a77e8', '#7e7bea', '#827eeb', '#8682ec', '#8a85ed', '#8e89ee',
 '#928cf0', '#9690f1', '#9993f2', '#9d97f3', '#a19af4', '#a59df6', '#a9a1f7',
 '#ada4f8', '#b1a8f9', '#b5abfa', '#b9affc', '#bdb2fd', '#c1b6fe', '#c5b9ff',
 '#c8bdfe', '#cbc1fe', '#cec5fd', '#d1c9fc', '#d5cdfc', '#d8d1fb', '#dbd5fa',
 '#ded9fa', '#e2ddf9', '#e5e1f8', '#e8e5f8', '#ebe9f7', '#efedf6', '#f2f1f6',
 '#f5f5f5', '#f5f1ef', '#f6ede8', '#f6e9e2', '#f6e5db', '#f7e1d5', '#f7ddce',
 '#f8d9c8', '#f8d5c1', '#f8d1ba', '#f9cdb3', '#f9c8ad', '#fac4a6', '#fac09f',
 '#fabb98', '#fbb791', '#fbb38a', '#fcae82', '#fcaa7b', '#fda573', '#fda06c',
 '#fd9b64', '#fe965c', '#fe9154', '#ff8c4b', '#fe8746', '#fd8342', '#fc7e3f',
 '#fb793b', '#f97538', '#f87034', '#f76b30', '#f5662d', '#f46129', '#f35c25',
 '#f15621', '#f0511d', '#ee4b18', '#ec4514', '#eb3e0f', '#e9380a', '#e73104',
 '#e42a00', '#e02800', '#db2600', '#d62400', '#d22200', '#cd2000', '#c81e00',
 '#c31c00', '#bf1a00', '#ba1800', '#b61600', '#b11400', '#ac1200', '#a81000',
 '#a30e00', '#9e0c00', '#9a0a00', '#950800', '#910600', '#8c0400', '#880200',
 '#840000']
cm6BuOr_list = \
['#003387', '#00368b', '#00398e', '#003c92', '#003f95', '#004299', '#00459c',
 '#0048a0', '#004ba3', '#004ea7', '#0051aa', '#0054ae', '#0057b1', '#005ab5',
 '#005db9', '#0060bc', '#0063c0', '#0066c4', '#0069c7', '#006ccb', '#006fcf',
 '#0072d2', '#0075d6', '#0078da', '#027cdd', '#077fde', '#0c83e0', '#1186e1',
 '#168ae3', '#1b8de4', '#2090e6', '#2594e7', '#2a97e8', '#2f9aea', '#349eeb',
 '#39a1ed', '#3ea4ee', '#42a8f0', '#47abf1', '#4caef2', '#51b2f4', '#55b5f5',
 '#5ab8f7', '#5fbbf8', '#64bef9', '#68c2fb', '#6dc5fc', '#72c8fe', '#76cbff',
 '#7fcefe', '#87d1fe', '#90d4fd', '#98d7fc', '#a0d9fc', '#a9dcfb', '#b1defa',
 '#b8e1fa', '#c0e4f9', '#c8e6f9', '#d0e9f8', '#d7ebf7', '#dfeef7', '#e6f0f6',
 '#eef3f6', '#f5f5f5', '#f6f2e5', '#f6eed6', '#f7ebc6', '#f7e7b5', '#f8e3a4',
 '#f8df92', '#f9db80', '#fad76e', '#fad35a', '#fbce46', '#fcca31', '#fdc51b',
 '#fdc004', '#fabc00', '#f7b900', '#f3b600', '#efb200', '#ebaf00', '#e7ac00',
 '#e4a900', '#e0a600', '#dca300', '#d89f00', '#d59c00', '#d19900', '#cd9600',
 '#c99300', '#c69000', '#c28d00', '#be8a00', '#bb8600', '#b78300', '#b48000',
 '#b07d00', '#ac7a00', '#a97700', '#a57400', '#a27100', '#9e6e00', '#9b6b00',
 '#986800', '#946500', '#916200', '#8e5f00', '#8a5c00', '#875900', '#845600',
 '#815300', '#7d5100', '#7a4e00', '#774b00', '#744800', '#714500', '#6e4200',
 '#6a3f00', '#673d00', '#643a00', '#613700', '#5e3400', '#5b3100', '#582f00',
 '#552c00', '#522900', '#4f2600']
RdBuX_list = \
['#840000', '#880200', '#8c0400', '#910600', '#950800', '#9a0a00', '#9e0b00',
 '#a30d00', '#a70f00', '#ac1100', '#b01300', '#b51500', '#b91700', '#be1900',
 '#c21b00', '#c71d00', '#cc1f00', '#d02100', '#d52300', '#da2500', '#de2800',
 '#e32a00', '#e62e02', '#e83508', '#ea3c0d', '#ec4212', '#ed4816', '#ef4e1b',
 '#f0541f', '#f25923', '#f35e27', '#f5632b', '#f6682f', '#f76d32', '#f97236',
 '#fa773a', '#fb7b3d', '#fc8040', '#fd8544', '#ff8947', '#ff8e4e', '#fe9356',
 '#fe985f', '#fd9d66', '#fda26e', '#fca676', '#fcab7d', '#fcaf84', '#fbb48b',
 '#fbb892', '#fabc99', '#fac1a0', '#fac5a7', '#f9c9ae', '#f9cdb5', '#f8d1bb',
 '#f8d5c2', '#f8d9c8', '#f7ddcf', '#f7e1d5', '#f6e5dc', '#f6e9e2', '#f6ede8',
 '#f5f1ef', '#f5f5f5', '#edf3f6', '#e5f0f6', '#dceef7', '#d4ecf8', '#cbe9f8',
 '#c3e7f9', '#bae5fa', '#b1e2fa', '#a8e0fb', '#9fddfc', '#96dafc', '#8cd8fd',
 '#82d5fe', '#79d2ff', '#71cffe', '#6dccfb', '#68c9f9', '#64c6f7', '#5fc2f4',
 '#5bbff2', '#56bcef', '#52b9ed', '#4db6ea', '#49b2e8', '#44afe6', '#40ace3',
 '#3ba9e1', '#37a5de', '#32a2dc', '#2e9fd9', '#299cd7', '#2499d5', '#2095d2',
 '#1b92d0', '#178fcd', '#128bcb', '#0e88c8', '#0985c6', '#0482c3', '#007ec1',
 '#007bbd', '#0078b9', '#0075b6', '#0072b2', '#006eaf', '#006bab', '#0068a8',
 '#0065a4', '#0062a1', '#005f9d', '#005c9a', '#005997', '#005693', '#005390',
 '#00508c', '#004d89', '#004a86', '#004782', '#00447f', '#00417c', '#003e79',
 '#003b75', '#003972', '#00366f']

RdBuMod = mpl_c.LinearSegmentedColormap.from_list( 'RdBuMod', RdBuMod_list )
RdBuMod_r = mpl_c.LinearSegmentedColormap.from_list( 'RdBuMod_r', RdBuMod_list[::-1] )
AquaIndigo = mpl_c.LinearSegmentedColormap.from_list( 'AquaIndigo', AquaIndigo_list )
AquaIndigo_r = mpl_c.LinearSegmentedColormap.from_list( 'AquaIndigo_r', AquaIndigo_list[::-1] )
NavyOrangeRed = mpl_c.LinearSegmentedColormap.from_list( 'NavyOrangeRed', NavyOrangeRed_list )
NavyOrangeRed_r = mpl_c.LinearSegmentedColormap.from_list( 'NavyOrangeRed_r', NavyOrangeRed_list[::-1] )
cm6BuOr = mpl_c.LinearSegmentedColormap.from_list( 'cm6BuOr', cm6BuOr_list )
cm6BuOr_r = mpl_c.LinearSegmentedColormap.from_list( 'cm6BuOr_r', cm6BuOr_list[::-1] )
RdBuX = mpl_c.LinearSegmentedColormap.from_list( 'RdBuX', RdBuX_list )
RdBuX_r = mpl_c.LinearSegmentedColormap.from_list( 'RdBuX_r', RdBuX_list[::-1] )

NavyOrangeRed_BL_list = \
['#6440cc', '#6340c9', '#6340c6', '#623fc4', '#613fc1', '#603fbe', '#5f3ebb',
 '#5f3eb8', '#5e3db5', '#5d3db3', '#5c3db0', '#5b3cad', '#5a3caa', '#5a3ca7',
 '#593ba5', '#583ba2', '#573b9f', '#563a9c', '#553a9a', '#543997', '#543994',
 '#533991', '#52388f', '#51388c', '#503789', '#4f3787', '#4e3784', '#4d3681',
 '#4c367f', '#4b357c', '#4a3579', '#493577', '#483474', '#473471', '#46336f',
 '#46336c', '#45336a', '#443267', '#433264', '#423162', '#41315f', '#40305d',
 '#3e305a', '#3d3058', '#3c2f55', '#3b2f53', '#3a2e50', '#392e4e', '#382d4b',
 '#372d49', '#362c47', '#352c44', '#342b42', '#332b3f', '#322b3d', '#302a3b',
 '#2f2a38', '#2e2936', '#2d2933', '#2c2831', '#2b282f', '#29272d', '#28272a',
 '#272628', '#282625', '#2b2625', '#2e2725', '#302724', '#332724', '#352724',
 '#382723', '#3a2823', '#3d2822', '#3f2822', '#422822', '#442821', '#462821',
 '#492920', '#4b2920', '#4d2920', '#50291f', '#52291f', '#54291e', '#57291e',
 '#59291e', '#5b291d', '#5d291d', '#60291c', '#62291c', '#64291b', '#67291b',
 '#69281a', '#6b281a', '#6e2819', '#702819', '#722818', '#742718', '#772717',
 '#792717', '#7b2616', '#7e2616', '#802615', '#822515', '#852514', '#872413',
 '#892413', '#8b2312', '#8e2211', '#902211', '#922110', '#95200f', '#97200f',
 '#991f0e', '#9c1e0d', '#9e1d0c', '#a01c0b', '#a31a0a', '#a5190a', '#a81809',
 '#aa1608', '#ac1407', '#af1206', '#b11005', '#b30e04', '#b60b03', '#b80702',
 '#bb0401', '#bd0000']

NavyOrangeRed_BL_full_list = \
['#886ffb', '#866df7', '#846cf2', '#826aee', '#8068ea', '#7e66e5', '#7b64e1',
 '#7963dd', '#7761d8', '#755fd4', '#735dd0', '#715ccb', '#6e5ac7', '#6c58c3',
 '#6a56bf', '#6855ba', '#6653b6', '#6451b2', '#624fae', '#604eaa', '#5e4ca6',
 '#5c4aa1', '#59499d', '#574799', '#554595', '#534491', '#51428d', '#4f4089',
 '#4d3f85', '#4b3d81', '#493b7d', '#473a79', '#453876', '#433772', '#41356e',
 '#3f336a', '#3d3266', '#3b3063', '#392f5f', '#372d5b', '#352b57', '#332a54',
 '#312850', '#30274d', '#2e2549', '#2c2445', '#2a2242', '#28213e', '#261f3b',
 '#241e37', '#221c34', '#201b31', '#1f192d', '#1d182a', '#1b1627', '#191524',
 '#171320', '#16121d', '#14101a', '#110d17', '#0e0b14', '#0b0810', '#07050b',
 '#040306', '#070201', '#0d0502', '#120703', '#160a04', '#1a0c05', '#1d0e06',
 '#201007', '#221209', '#25130a', '#28140b', '#2b150c', '#2e170d', '#31180d',
 '#35190e', '#381a0f', '#3b1b10', '#3e1c10', '#421e11', '#451f11', '#482012',
 '#4c2112', '#4f2213', '#532313', '#562514', '#5a2614', '#5d2715', '#612815',
 '#642915', '#682a16', '#6b2c16', '#6f2d17', '#722e17', '#762f17', '#7a3018',
 '#7d3118', '#813318', '#853419', '#883519', '#8c361a', '#90371a', '#94381a',
 '#983a1b', '#9b3b1b', '#9f3c1b', '#a33d1c', '#a73e1c', '#ab401c', '#af411d',
 '#b3421d', '#b6431d', '#ba441e', '#be451e', '#c2471e', '#c6481f', '#ca491f',
 '#ce4a1f', '#d24b1f', '#d64d20', '#da4e20', '#de4f20', '#e25021', '#e75121',
 '#eb5321', '#ef5421']

NORBL_list = \
['#d15417', '#cf5419', '#cd541a', '#cb541b', '#c9541c', '#c7541e', '#c5541f',
 '#c35420', '#c15421', '#bf5422', '#bd5423', '#bb5424', '#b95425', '#b75426',
 '#b55427', '#b35428', '#b15429', '#af5329', '#ad532a', '#ab532b', '#a9532c',
 '#a7532d', '#a5532e', '#a3532e', '#a1532f', '#9f5330', '#9d5231', '#9b5231',
 '#995232', '#975233', '#945234', '#925234', '#905235', '#8e5136', '#8c5137',
 '#8a5137', '#885138', '#865139', '#845039', '#82503a', '#80503b', '#7e503b',
 '#7c503c', '#7a4f3d', '#774f3d', '#754f3e', '#734f3f', '#714e3f', '#6f4e40',
 '#6d4e40', '#6a4e41', '#684d42', '#664d42', '#644d43', '#624d44', '#5f4c44',
 '#5d4c45', '#5b4c45', '#584b46', '#564b47', '#544b47', '#514a48', '#4f4a48',
 '#4c4a49', '#4a4a4c', '#4b4b4e', '#4c4b50', '#4d4c53', '#4e4c55', '#4f4d57',
 '#4f4d5a', '#504e5c', '#514e5e', '#524f60', '#535063', '#535065', '#545168',
 '#55516a', '#55526c', '#56526f', '#575371', '#585373', '#585476', '#595478',
 '#5a557b', '#5a567d', '#5b567f', '#5b5782', '#5c5784', '#5d5887', '#5d5889',
 '#5e598c', '#5e598e', '#5f5a90', '#605b93', '#605b95', '#615c98', '#615c9a',
 '#625d9d', '#625d9f', '#635ea2', '#635fa4', '#645fa7', '#6460a9', '#6460ac',
 '#6561ae', '#6561b1', '#6662b4', '#6662b6', '#6663b9', '#6764bb', '#6764be',
 '#6765c0', '#6865c3', '#6866c6', '#6866c8', '#6967cb', '#6968cd', '#6968d0',
 '#6a69d3', '#6a69d5', '#6a6ad8', '#6a6ada', '#6a6bdd', '#6b6ce0', '#6b6ce2',
 '#6b6de5', '#6b6de8']

NavyOrangeRed_BL = mpl_c.LinearSegmentedColormap.from_list( 'NavyOrangeRed_BL', NavyOrangeRed_BL_list )
NavyOrangeRed_BL_r = mpl_c.LinearSegmentedColormap.from_list( 'NavyOrangeRed_BL_r', NavyOrangeRed_BL_list[::-1] )
NavyOrangeRed_BL_full = mpl_c.LinearSegmentedColormap.from_list( 'NavyOrangeRed_BL_full', NavyOrangeRed_BL_full_list )
NavyOrangeRed_BL_full_r = mpl_c.LinearSegmentedColormap.from_list( 'NavyOrangeRed_BL_full_r', NavyOrangeRed_BL_full_list[::-1] )
NORBL = mpl_c.LinearSegmentedColormap.from_list( 'NORBL', NORBL_list )
NORBL_r = mpl_c.LinearSegmentedColormap.from_list( 'NORBL_r', NORBL_list[::-1] )

Cycl_wdiv4_list = [ (0.820, 0.369, 0.333),
                    (0.600, 0.420, 0.733),
                    (0.341, 0.729, 0.812),
                    (0.561, 0.702, 0.455),
                    (0.820, 0.369, 0.333) ]
Cycl_wdiv4 = mpl_c.LinearSegmentedColormap.from_list('Cycl_wdiv4', Cycl_wdiv4_list)
Cycl_wdiv4_r = mpl_c.LinearSegmentedColormap.from_list('Cycl_wdiv4_r', Cycl_wdiv4_list[::-1])

young_list = ['#3bfaff', '#3af5fe', '#38f1fe', '#37ecfd', '#36e7fc', '#35e2fc',
              '#34defb', '#33d9fa', '#32d4fa', '#31cff9', '#30cbf9', '#2ec6f8',
              '#2dc1f7', '#2cbcf7', '#2bb8f6', '#2ab3f5', '#29aef5', '#28aaf4',
              '#27a5f3', '#26a0f3', '#249bf2', '#2397f1', '#2292f1', '#218df0',
              '#2088ef', '#1f83ef', '#1e7fee', '#1d7aed', '#1b75ed', '#1a70ec',
              '#196beb', '#1866eb', '#1761ea', '#155be9', '#1456e9', '#1350e8',
              '#124be7', '#1045e6', '#0f3fe5', '#0d39e5', '#0c32e4', '#0a2ae3',
              '#0822e1', '#0618e0', '#020ade', '#0000d9', '#0000d0', '#0000c6',
              '#0000bd', '#0000b4', '#0000aa', '#0000a1', '#000098', '#000090',
              '#000087', '#00007e', '#000076', '#00006d', '#000065', '#00005c',
              '#000053', '#000048', '#00003b', '#000028', '#140003', '#200005',
              '#280006', '#2f0007', '#350008', '#3b0009', '#40000a', '#45000a',
              '#4b000b', '#50000c', '#56000d', '#5c000e', '#61000f', '#670010',
              '#6d0010', '#730011', '#790012', '#7f0013', '#850014', '#8b0015',
              '#910016', '#980017', '#9e0018', '#a40019', '#aa001a', '#b1001b',
              '#b7001c', '#be001d', '#c4001e', '#cb001f', '#d10020', '#d80021',
              '#df0022', '#e50023', '#ec0024', '#f30025', '#fa0026', '#ff0e24',
              '#ff2a1f', '#ff3b1d', '#ff471a', '#ff5219', '#ff5c17', '#ff6515',
              '#ff6d14', '#ff7513', '#ff7d11', '#ff8410', '#ff8b0f', '#ff920e',
              '#ff980d', '#ff9f0c', '#ffa50b', '#ffab0a', '#ffb109', '#ffb708',
              '#ffbd07', '#ffc306', '#ffc905', '#ffce04', '#ffd403', '#ffda02',
              '#ffdf01', '#ffe500']
BluePurpleRedor_list = ['#b9ffff', '#b9fdfe', '#bafbfe', '#bafafd', '#baf8fc',
                        '#bbf6fc', '#bbf4fb', '#bbf2fa', '#bbf0fa', '#bceef9',
                        '#bcedf8', '#bcebf8', '#bde9f7', '#bde7f6', '#bde5f6',
                        '#bee3f5', '#bee1f4', '#bedff4', '#bfddf3', '#bfdcf2',
                        '#bfdaf2', '#c0d8f1', '#c0d6f0', '#c0d4f0', '#c1d2ef',
                        '#c1d0ee', '#c1ceee', '#c2cced', '#c2caec', '#c2c9ec',
                        '#c3c6eb', '#c3c5ea', '#c3c3ea', '#c4c1e9', '#c4bfe8',
                        '#c4bde8', '#c5bbe7', '#c5b9e6', '#c5b7e5', '#c6b5e5',
                        '#c6b3e4', '#c6b1e3', '#c7afe3', '#c7ade2', '#c7abe1',
                        '#c8a9e0', '#c8a7e0', '#c8a4df', '#c9a2de', '#c9a0dd',
                        '#ca9edd', '#ca9cdc', '#ca9adb', '#cb98da', '#cb95da',
                        '#cb93d9', '#cc91d8', '#cc8fd7', '#cd8dd6', '#cd8ad6',
                        '#cd88d5', '#ce86d4', '#ce83d3', '#cf81d2', '#cf7ed1',
                        '#cf7cd1', '#d07ad0', '#d077cf', '#d075ce', '#d073cb',
                        '#cf72c8', '#cf70c5', '#ce6fc3', '#cd6dc0', '#cd6bbd',
                        '#cc6aba', '#cb68b8', '#cb67b5', '#ca65b2', '#ca64af',
                        '#c962ad', '#c860aa', '#c85fa7', '#c75da4', '#c65ca1',
                        '#c65a9f', '#c5589c', '#c45799', '#c45596', '#c35493',
                        '#c25290', '#c2508d', '#c14f8a', '#c04d87', '#c04b84',
                        '#bf4981', '#be487e', '#bd467b', '#bd4478', '#bc4275',
                        '#bb4172', '#bb3f6f', '#ba3d6b', '#b93b68', '#b83965',
                        '#b83762', '#b7365e', '#b6345b', '#b53257', '#b43054',
                        '#b42e50', '#b32c4d', '#b22949', '#b12745', '#b02541',
                        '#af233d', '#ae2039', '#ad1e35', '#ac1c30', '#ab192c',
                        '#aa1627', '#a91422', '#a8111d', '#a70e18', '#a50a12',
                        '#a4070c', '#a20306', '#a10000']
PrinsensvlagLinear_list = ['#ffff9a', '#fffd99', '#fffa98', '#fff898',
                           '#fff597', '#fff396', '#fff095', '#ffee95',
                           '#ffeb94', '#ffe993', '#ffe693', '#ffe492',
                           '#ffe191', '#ffde90', '#ffdc90', '#ffd98f',
                           '#ffd78e', '#ffd48e', '#ffd28d', '#ffcf8c',
                           '#ffcc8b', '#ffca8b', '#ffc78a', '#ffc589',
                           '#ffc288', '#ffbf88', '#ffbd87', '#ffba86',
                           '#ffb785', '#feb585', '#f9b485', '#f4b486',
                           '#f0b386', '#ebb387', '#e6b287', '#e1b188',
                           '#dcb189', '#d7b089', '#d2af8a', '#cdaf8a',
                           '#c7ae8b', '#c2ad8b', '#bdad8c', '#b8ac8d',
                           '#b2ab8d', '#acaa8e', '#a7aa8e', '#a1a98f',
                           '#9ba890', '#95a790', '#8fa791', '#89a692',
                           '#82a592', '#7ba493', '#75a394', '#6da295',
                           '#66a196', '#5fa096', '#579f97', '#4e9e98',
                           '#459d99', '#3c9c9a', '#329b9b', '#27999d',
                           '#1a979e', '#0d96a0', '#0094a1', '#0092a0',
                           '#0090a0', '#008e9f', '#008c9f', '#008a9f',
                           '#00889e', '#00869e', '#00849d', '#00829d',
                           '#00809c', '#007e9c', '#007c9b', '#007a9b',
                           '#00789a', '#00769a', '#007599', '#007399',
                           '#007198', '#006f98', '#006d98', '#006b97',
                           '#006997', '#006796', '#006596', '#006395',
                           '#006195', '#005f94', '#005d94', '#005b93',
                           '#005993', '#005792', '#005592', '#005392',
                           '#005291', '#005091', '#004e90', '#004c90',
                           '#004a8f', '#00488f', '#00468e', '#00448e',
                           '#00428d', '#00408d', '#003e8c', '#003c8c',
                           '#00398b', '#00378b', '#00358a', '#00338a',
                           '#003189', '#002f89', '#002d88', '#002b88',
                           '#002887', '#002687', '#002486', '#002186',
                           '#001f85', '#001c84', '#001984', '#001783']
nihit_list = ['#000300', '#000a0a', '#011113', '#01181d', '#021f27', '#022631',
              '#032e3a', '#033544', '#033c4e', '#044358', '#044a61', '#05516b',
              '#055875', '#065f7e', '#066688', '#066d92', '#07749c', '#077ba5',
              '#0883af', '#088ab9', '#0991c2', '#0998cc', '#0a9fd6', '#0aa6e0',
              '#0aade9', '#0bb4f3', '#0db4f3', '#0fafed', '#12aae7', '#15a4e0',
              '#179fda', '#1a9ad4', '#1d95cd', '#2090c7', '#228bc1', '#2585bb',
              '#2880b4', '#2b7bae', '#2d76a8', '#3071a1', '#336c9b', '#356795',
              '#38618e', '#3b5c88', '#3e5782', '#40527c', '#434d75', '#46486f',
              '#484269', '#4b3d62', '#4e385c', '#513456', '#563354', '#5c3251',
              '#61314f', '#66314c', '#6c304a', '#712f47', '#762e45', '#7c2d42',
              '#812c40', '#862c3d', '#8c2b3b', '#912a38', '#962936', '#9b2833',
              '#a12731', '#a6272e', '#ab262c', '#b12529', '#b62427', '#bb2324',
              '#c12222', '#c6221f', '#cb211d', '#d1201a', '#d61f18', '#d82217',
              '#d92517', '#db2917', '#dc2c16', '#dd3016', '#df3316', '#e03716',
              '#e13a16', '#e33e16', '#e44115', '#e54515', '#e74815', '#e84c15',
              '#e94f15', '#eb5315', '#ec5615', '#ed5a14', '#ef5d14', '#f06114',
              '#f26414', '#f36814', '#f46b14', '#f66f13', '#f77213', '#f87613',
              '#f97a13', '#f97f12', '#f88512', '#f88a11', '#f88f11', '#f79510',
              '#f79a10', '#f79f0f', '#f6a50f', '#f6aa0e', '#f6af0e', '#f5b50d',
              '#f5ba0d', '#f5bf0c', '#f4c50c', '#f4ca0b', '#f4cf0b', '#f4d40a',
              '#f3da0a', '#f3df09', '#f3e409', '#f2ea08', '#f2ef08', '#f2f407',
              '#f1fa07', '#f1ff06']
keda_list = ['#fefbf4', '#fdf5e5', '#fbf2d9', '#f9edcc', '#f8eac0', '#f7e8b6',
             '#f7e4ab', '#f6e0a1', '#f5de97', '#f4da8d', '#f2d785', '#f1d37c',
             '#f1d172', '#f0ce6b', '#f1cb63', '#efc85d', '#efc653', '#eec24c',
             '#eebf47', '#e9ba46', '#e8b546', '#e4b046', '#e2ab46', '#dea545',
             '#dca244', '#d99c44', '#d79845', '#d49344', '#d28d42', '#cf8a43',
             '#cd8643', '#cb8243', '#c87b42', '#c57740', '#c2723f', '#c16e3f',
             '#bd693f', '#b76841', '#b06843', '#a96845', '#a2674a', '#9b664c',
             '#94664e', '#8e6652', '#876655', '#816558', '#7a655b', '#75655f',
             '#6f6561', '#696465', '#636468', '#5e646c', '#59636f', '#536272',
             '#4f6175', '#4b6078', '#495e78', '#475a77', '#465877', '#455475',
             '#435174', '#424f73', '#404b72', '#3f4971', '#3e4670', '#3c4470',
             '#3b406e', '#393e6d', '#383c6c', '#36386b', '#353769', '#343469',
             '#323369', '#313066', '#302d63', '#2e2c5d', '#2c2a55', '#2a284f',
             '#272549', '#252445', '#23213f', '#211e39', '#1f1c33', '#1c1a2e',
             '#1a1829', '#181724', '#161521', '#15141d', '#141319', '#121216',
             '#111113']

young = mpl_c.LinearSegmentedColormap.from_list('young', young_list)
young_r = mpl_c.LinearSegmentedColormap.from_list('young_r', young_list[::-1])
BluePurpleRedor = mpl_c.LinearSegmentedColormap.from_list('BluePurpleRedor', BluePurpleRedor_list)
BluePurpleRedor_r = mpl_c.LinearSegmentedColormap.from_list('BluePurpleRedor_r', BluePurpleRedor_list[::-1])
PrinsensvlagLinear = mpl_c.LinearSegmentedColormap.from_list('PrinsensvlagLinear', PrinsensvlagLinear_list)
PrinsensvlagLinear_r = mpl_c.LinearSegmentedColormap.from_list('PrinsensvlagLinear_r', PrinsensvlagLinear_list[::-1])
nihit = mpl_c.LinearSegmentedColormap.from_list('nihit', nihit_list)
nihit_r = mpl_c.LinearSegmentedColormap.from_list('nihit_r', nihit_list[::-1])
keda = mpl_c.LinearSegmentedColormap.from_list('keda', keda_list)
keda_r = mpl_c.LinearSegmentedColormap.from_list('keda_r', keda_list[::-1])

schumann_urban_greens_list = \
    ['#51ff9e', '#50fd9d', '#50fa9c', '#4ff89a', '#4ff699', '#4ff498',
     '#4ef196', '#4eef95', '#4ded94', '#4deb92', '#4ce891', '#4ce690',
     '#4be48e', '#4be28d', '#4ae08c', '#4add8a', '#49db89', '#49d988',
     '#48d786', '#48d485', '#47d284', '#47d082', '#46ce81', '#46cc80',
     '#45ca7e', '#45c77d', '#44c57c', '#44c37b', '#43c179', '#43bf78',
     '#42bd77', '#42ba75', '#41b874', '#41b673', '#40b472', '#40b270',
     '#3fb06f', '#3fae6e', '#3eac6c', '#3ea96b', '#3da76a', '#3da569',
     '#3ca367', '#3ca166', '#3b9f65', '#3b9d64', '#3a9b62', '#3a9961',
     '#399760', '#39955f', '#38935d', '#38905c', '#378e5b', '#378c5a',
     '#368a58', '#368857', '#358656', '#348455', '#348254', '#338052',
     '#337e51', '#327c50', '#327a4f', '#31784e', '#31764c', '#30744b',
     '#2f724a', '#2f7049', '#2e6e48', '#2e6d46', '#2d6b45', '#2d6944',
     '#2c6743', '#2b6542', '#2b6341', '#2a613f', '#2a5f3e', '#295d3d',
     '#295b3c', '#28593b', '#27573a', '#275639', '#265437', '#265236',
     '#255035', '#244e34', '#244c33', '#234b32', '#234931', '#224730',
     '#21452e', '#21432d', '#20412c', '#20402b', '#1f3e2a', '#1e3c29',
     '#1e3a28', '#1d3927', '#1c3726', '#1c3525', '#1b3324', '#1b3223',
     '#1a3021', '#192e20', '#192d1f', '#182b1e', '#17291d', '#17281c',
     '#16261b', '#15241a', '#152319', '#142118', '#131f17', '#131e16',
     '#121c15', '#111b14', '#101913', '#0f1811', '#0e1610', '#0c140f',
     '#0b120d', '#09100b', '#080e0a', '#060c08', '#050906', '#030604',
     '#020302', '#000000']
schumann_urban_blues_list = \
    ['#85dfff', '#84ddfe', '#84dbfd', '#83d9fb', '#82d7fa', '#82d4f9',
     '#81d2f8', '#80d0f6', '#7fcef5', '#7fccf4', '#7ecaf3', '#7dc8f1',
     '#7cc6f0', '#7bc3ef', '#7bc1ed', '#7abfec', '#79bdeb', '#78bbea',
     '#77b9e8', '#77b7e7', '#76b5e6', '#75b3e4', '#74b1e3', '#73afe2',
     '#72ade0', '#72abdf', '#71a8dd', '#70a6dc', '#6fa4db', '#6ea2d9',
     '#6da0d8', '#6c9ed6', '#6c9cd5', '#6b9ad4', '#6a98d2', '#6996d1',
     '#6894cf', '#6792ce', '#6690cc', '#658ecb', '#648cc9', '#638ac8',
     '#6289c7', '#6187c5', '#6185c3', '#6083c2', '#5f81c0', '#5e7fbf',
     '#5d7dbd', '#5c7bbc', '#5b79ba', '#5a77b9', '#5975b7', '#5873b6',
     '#5772b4', '#5670b2', '#556eb1', '#546caf', '#536aad', '#5268ac',
     '#5166aa', '#5065a8', '#4f63a7', '#4e61a5', '#4d5fa3', '#4c5da2',
     '#4b5ca0', '#4a5a9e', '#49589c', '#48569b', '#475599', '#465397',
     '#455195', '#444f94', '#434e92', '#424c90', '#414a8e', '#3f488c',
     '#3e478a', '#3d4588', '#3c4386', '#3b4284', '#3a4083', '#393e81',
     '#383d7f', '#373b7d', '#363a7b', '#353879', '#343676', '#333574',
     '#323372', '#313270', '#30306e', '#2f2f6c', '#2e2d6a', '#2d2c68',
     '#2c2a65', '#2b2963', '#2a2761', '#29265e', '#28245c', '#27235a',
     '#262257', '#252055', '#241f52', '#231e50', '#221c4d', '#211b4b',
     '#201a48', '#1f1946', '#1e1743', '#1d1640', '#1c153d', '#1b143b',
     '#1a1338', '#191235', '#181132', '#170f2e', '#160e2b', '#150c28',
     '#150b25', '#130921', '#12071e', '#10051a', '#0d0416', '#090211',
     '#05010a', '#000000']
schumann_urban_reds_list = \
    ['#ffc0d6', '#ffbed5', '#ffbbd3', '#ffb8d1', '#ffb5cf', '#ffb3cd',
     '#ffb0cb', '#feaec9', '#feabc7', '#fea8c5', '#fda6c3', '#fca3c1',
     '#fca1bf', '#fb9ebe', '#fa9cbc', '#f99aba', '#f997b8', '#f895b6',
     '#f792b4', '#f690b2', '#f48eb0', '#f38caf', '#f289ad', '#f187ab',
     '#f085a9', '#ee83a7', '#ed80a5', '#ec7ea4', '#ea7ca2', '#e97aa0',
     '#e7789e', '#e6769c', '#e4749a', '#e27299', '#e17097', '#df6e95',
     '#dd6c93', '#dc6a92', '#da6890', '#d8668e', '#d6648c', '#d4638b',
     '#d26189', '#d15f87', '#cf5d85', '#cd5b84', '#cb5a82', '#c95880',
     '#c7567e', '#c5557d', '#c3537b', '#c05179', '#be5078', '#bc4e76',
     '#ba4d74', '#b84b72', '#b64a71', '#b4486f', '#b1476d', '#af456c',
     '#ad446a', '#ab4368', '#a84167', '#a64065', '#a43e63', '#a13d62',
     '#9f3c60', '#9d3b5f', '#9a395d', '#98385b', '#96375a', '#933658',
     '#913556', '#8e3355', '#8c3253', '#893152', '#873050', '#852f4f',
     '#822e4d', '#802d4b', '#7d2c4a', '#7b2b48', '#782a47', '#762945',
     '#732844', '#712742', '#6e2641', '#6c263f', '#69253e', '#67243c',
     '#64233b', '#622239', '#5f2138', '#5d2136', '#5a2035', '#581f33',
     '#551e32', '#531e30', '#501d2f', '#4e1c2d', '#4b1b2c', '#491b2b',
     '#461a29', '#441928', '#411926', '#3f1825', '#3c1724', '#3a1722',
     '#371621', '#35151f', '#32151e', '#30141d', '#2d131b', '#2b131a',
     '#281219', '#261117', '#231016', '#210f15', '#1f0e13', '#1d0d12',
     '#1b0b10', '#180a0e', '#15080c', '#12060a', '#0f0507', '#0a0305',
     '#050202', '#000000']
schumann_urban_greens = mpl_c.LinearSegmentedColormap.from_list('schumann_urban_greens', schumann_urban_greens_list)
schumann_urban_greens_r = mpl_c.LinearSegmentedColormap.from_list('schumann_urban_greens_r', schumann_urban_greens_list[::-1])
schumann_urban_blues = mpl_c.LinearSegmentedColormap.from_list('schumann_urban_blues', schumann_urban_blues_list)
schumann_urban_blues_r = mpl_c.LinearSegmentedColormap.from_list('schumann_urban_blues_r', schumann_urban_blues_list[::-1])
schumann_urban_reds = mpl_c.LinearSegmentedColormap.from_list('schumann_urban_reds', schumann_urban_reds_list)
schumann_urban_reds_r = mpl_c.LinearSegmentedColormap.from_list('schumann_urban_reds_r', schumann_urban_reds_list[::-1])

cmasher_greens_list = \
    ['#a8fa91', '#a4f88d', '#a1f68a', '#9ef488', '#9bf285', '#99f083',
     '#97ee81', '#94ec7f', '#92ea7d', '#90e87b', '#8ee679', '#8ce477',
     '#8ae276', '#89e074', '#87de72', '#85dc71', '#83d96f', '#82d76e',
     '#80d56c', '#7ed36b', '#7dd16a', '#7bcf68', '#79cd67', '#78cb65',
     '#76c964', '#75c663', '#73c462', '#72c260', '#71c05f', '#6fbe5e',
     '#6ebc5d', '#6cba5b', '#6bb85a', '#6ab659', '#68b458', '#67b257',
     '#66af56', '#64ad54', '#63ab53', '#62a952', '#60a751', '#5fa550',
     '#5ea34f', '#5da14e', '#5b9f4d', '#5a9d4c', '#599b4b', '#58994a',
     '#569749', '#559548', '#549347', '#539146', '#528f45', '#518d44',
     '#4f8a43', '#4e8942', '#4d8641', '#4c8440', '#4b823f', '#4a803e',
     '#497e3d', '#487c3c', '#477b3b', '#45793a', '#44773a', '#437539',
     '#427338', '#417137', '#406f36', '#3f6d35', '#3e6b34', '#3d6933',
     '#3c6732', '#3b6532', '#3a6331', '#396130', '#385f2f', '#375d2e',
     '#365c2d', '#355a2d', '#34582c', '#33562b', '#32542a', '#315229',
     '#305028', '#2f4e28', '#2e4d27', '#2d4b26', '#2c4925', '#2b4724',
     '#2a4524', '#294423', '#284222', '#274021', '#263e21', '#253c20',
     '#243b1f', '#24391e', '#23371d', '#22351d', '#21341c', '#20321b',
     '#1f301a', '#1e2e1a', '#1d2d19', '#1c2b18', '#1b2918', '#1a2817',
     '#192616', '#192415', '#182315', '#172114', '#162013', '#151e12',
     '#141c11', '#131b10', '#12190f', '#11180e', '#10160d', '#0e140b',
     '#0d130a', '#0b1109', '#090e07', '#070c06', '#060904', '#040603',
     '#020301', '#000000']
cmasher_oranges_list = \
    ['#ffe17b', '#ffde78', '#fedc75', '#fed972', '#fdd770', '#fcd46d',
     '#fbd26b', '#fad068', '#f9cd66', '#f8cb64', '#f7c962', '#f5c660',
     '#f4c45e', '#f3c25c', '#f1c05a', '#f0bd58', '#eebb56', '#edb955',
     '#ebb753', '#e9b551', '#e8b350', '#e6b04e', '#e4ae4d', '#e2ac4b',
     '#e1aa4a', '#dfa848', '#dda647', '#dba446', '#d9a244', '#d7a043',
     '#d59e42', '#d39c41', '#d19a3f', '#cf983e', '#cd963d', '#cb943c',
     '#c9923b', '#c7913a', '#c58f39', '#c38d38', '#c18b37', '#bf8936',
     '#bd8735', '#bb8534', '#b98433', '#b78232', '#b58031', '#b37e30',
     '#b07c2f', '#ae7a2e', '#ac792e', '#aa772d', '#a8752c', '#a6732b',
     '#a3722b', '#a1702a', '#9f6e29', '#9d6c28', '#9b6b28', '#996927',
     '#966726', '#946626', '#926425', '#906224', '#8e6124', '#8b5f23',
     '#895d23', '#875c22', '#855a21', '#825821', '#805720', '#7e5520',
     '#7c541f', '#7a521f', '#77511e', '#754f1e', '#734d1d', '#714c1d',
     '#6f4a1c', '#6c491c', '#6a471b', '#68461b', '#66441a', '#64431a',
     '#624119', '#5f4019', '#5d3e19', '#5b3d18', '#593b18', '#573a17',
     '#543817', '#523716', '#503516', '#4e3416', '#4c3315', '#4a3115',
     '#483014', '#462e14', '#432d14', '#412c13', '#3f2a13', '#3d2913',
     '#3b2812', '#392612', '#372511', '#352411', '#332210', '#312110',
     '#2f200f', '#2d1e0f', '#2b1d0e', '#291c0d', '#271a0d', '#25190c',
     '#23180b', '#21170a', '#1f1509', '#1d1408', '#1b1308', '#191107',
     '#170f06', '#150d05', '#130b04', '#100903', '#0c0702', '#080502',
     '#040201', '#000000']
cmasher_purples_list = \
    ['#ffdbeb', '#fed9e9', '#fcd7e7', '#fbd4e5', '#fad2e3', '#f9d0e1',
     '#f7cddf', '#f6cbdd', '#f5c9db', '#f3c7d9', '#f2c4d7', '#f1c2d4',
     '#efc0d3', '#eebed0', '#edbbce', '#ebb9cc', '#eab7ca', '#e8b5c8',
     '#e7b3c6', '#e5b0c4', '#e4aec2', '#e2acc0', '#e1aabe', '#dfa8bc',
     '#dea5ba', '#dca3b8', '#dba1b6', '#d99fb4', '#d89db3', '#d69bb1',
     '#d599af', '#d397ad', '#d195ab', '#d092a9', '#ce90a7', '#cd8ea5',
     '#cb8ca3', '#c98aa1', '#c8889f', '#c6869d', '#c4849b', '#c28299',
     '#c18097', '#bf7e95', '#bd7c94', '#bc7a92', '#ba7890', '#b8768e',
     '#b6748c', '#b5728a', '#b37088', '#b16e86', '#af6c84', '#ad6b83',
     '#ab6981', '#aa677f', '#a8657d', '#a6637b', '#a46179', '#a25f77',
     '#a05e76', '#9e5c74', '#9c5a72', '#9a5870', '#98566e', '#96556d',
     '#94536b', '#925169', '#915067', '#8f4e65', '#8c4c64', '#8a4a62',
     '#884960', '#86475e', '#84455c', '#82445b', '#804259', '#7e4157',
     '#7c3f55', '#7a3e54', '#783c52', '#763a50', '#74394f', '#71374d',
     '#6f364b', '#6d3549', '#6b3348', '#693246', '#673044', '#642f43',
     '#622e41', '#602c3f', '#5e2b3e', '#5b2a3c', '#59283a', '#572739',
     '#552637', '#522535', '#502334', '#4e2232', '#4b2131', '#49202f',
     '#471f2d', '#441e2c', '#421d2a', '#401c29', '#3d1b27', '#3b1a26',
     '#381924', '#361822', '#341721', '#31161f', '#2f151e', '#2c141c',
     '#2a131b', '#271219', '#251118', '#231016', '#200f15', '#1e0e13',
     '#1c0c11', '#190a0f', '#17090d', '#13070b', '#100508', '#0b0305',
     '#060203', '#000000']
cmasher_greens_nobezier_list = \
    ['#cbf451', '#c4f352', '#bcf252', '#b4f152', '#acf052', '#a4ef52',
     '#9bee53', '#92ed53', '#89ec53', '#80eb53', '#76ea54', '#6be954',
     '#66e754', '#65e553', '#64e252', '#63e051', '#62de50', '#61dc50',
     '#60da4f', '#5fd74e', '#5ed54d', '#5dd34c', '#5cd14c', '#5bce4b',
     '#5acc4a', '#59ca49', '#58c848', '#57c648', '#56c447', '#55c146',
     '#54bf45', '#53bd44', '#52bb44', '#51b943', '#50b742', '#4fb541',
     '#4eb241', '#4eb040', '#4dae3f', '#4cac3e', '#4baa3e', '#4aa83d',
     '#49a63c', '#48a43b', '#47a23a', '#469f3a', '#459d39', '#449b38',
     '#439937', '#429737', '#429536', '#419335', '#409134', '#3f8f34',
     '#3e8d33', '#3d8b32', '#3c8932', '#3b8731', '#3a8530', '#39832f',
     '#39812f', '#387f2e', '#377d2d', '#367b2c', '#35792c', '#34772b',
     '#33752a', '#32732a', '#327129', '#316f28', '#306d27', '#2f6b27',
     '#2e6926', '#2d6725', '#2c6525', '#2c6324', '#2b6123', '#2a5f23',
     '#295d22', '#285c21', '#275a20', '#275820', '#26561f', '#25541e',
     '#24521e', '#23501d', '#224e1c', '#224d1c', '#214b1b', '#20491a',
     '#1f471a', '#1e4519', '#1e4318', '#1d4218', '#1c4017', '#1b3e16',
     '#1b3c16', '#1a3b15', '#193915', '#183714', '#173513', '#173413',
     '#163212', '#153011', '#142e11', '#142d10', '#132b10', '#12290f',
     '#11280e', '#11260e', '#10240d', '#0f230d', '#0f210c', '#0e200b',
     '#0d1e0b', '#0c1c0a', '#0c1b0a', '#0b1909', '#0a1708', '#091508',
     '#091307', '#081106', '#070f05', '#050c04', '#040903', '#030602',
     '#010301', '#000000']
cmasher_oranges_nobezier_list = \
    ['#ffe0aa', '#fedda5', '#fedba1', '#fdd99c', '#fdd697', '#fcd493',
     '#fcd18e', '#fbcf8a', '#fbcd85', '#faca80', '#fac87c', '#f9c577',
     '#f9c372', '#f8c06d', '#f8be69', '#f7bb64', '#f6b95f', '#f6b65a',
     '#f5b455', '#f5b151', '#f4af4c', '#f4ac47', '#f3a942', '#f3a73d',
     '#f2a438', '#f1a233', '#f19f2e', '#f09c29', '#f09923', '#ef971e',
     '#ee9419', '#ed9215', '#eb9015', '#e88e14', '#e58d14', '#e38b14',
     '#e08914', '#dd8814', '#db8613', '#d88413', '#d58313', '#d38113',
     '#d08012', '#cd7e12', '#cb7c12', '#c87b12', '#c57911', '#c37711',
     '#c07611', '#be7411', '#bb7310', '#b87110', '#b67010', '#b36e10',
     '#b16c10', '#ae6b0f', '#ac690f', '#a9680f', '#a6660f', '#a4650e',
     '#a1630e', '#9f620e', '#9c600e', '#9a5e0e', '#975d0d', '#955b0d',
     '#925a0d', '#90580d', '#8e570c', '#8b550c', '#89540c', '#86520c',
     '#84510c', '#814f0b', '#7f4e0b', '#7c4c0b', '#7a4b0b', '#78490b',
     '#75480a', '#73460a', '#71450a', '#6e440a', '#6c420a', '#694109',
     '#673f09', '#653e09', '#633c09', '#603b08', '#5e3a08', '#5c3808',
     '#593708', '#573508', '#553407', '#533307', '#503107', '#4e3007',
     '#4c2f07', '#4a2d06', '#472c06', '#452a06', '#432906', '#412806',
     '#3f2606', '#3d2505', '#3a2405', '#382305', '#362105', '#342005',
     '#321f04', '#301d04', '#2e1c04', '#2c1b04', '#2a1a04', '#281804',
     '#261703', '#241603', '#221503', '#201303', '#1e1203', '#1b1102',
     '#190f02', '#160d02', '#130c02', '#100a01', '#0c0701', '#080501',
     '#040200', '#000000']
cmasher_purples_nobezier_list = \
    ['#ffdbeb', '#fed9e9', '#fcd7e7', '#fbd4e6', '#fad2e4', '#f8d0e2',
     '#f7cde0', '#f6cbde', '#f4c9dc', '#f3c6db', '#f2c4d9', '#f1c2d7',
     '#efc0d5', '#eebdd3', '#edbbd2', '#ebb9d0', '#eab6ce', '#e9b4cc',
     '#e7b2ca', '#e6b0c9', '#e5adc7', '#e4abc5', '#e2a9c3', '#e1a6c1',
     '#e0a4c0', '#dea2be', '#dda0bc', '#dc9dba', '#da9bb8', '#d999b7',
     '#d896b5', '#d794b3', '#d592b1', '#d490b0', '#d38dae', '#d18bac',
     '#d089aa', '#cf86a8', '#cd84a7', '#cc82a5', '#cb80a3', '#ca7da1',
     '#c87b9f', '#c7799e', '#c6769c', '#c4749a', '#c37298', '#c27096',
     '#c06d95', '#bf6b93', '#be6991', '#bc668f', '#bb648d', '#ba628b',
     '#b95f8a', '#b75d88', '#b65b86', '#b55884', '#b35682', '#b25480',
     '#b1517e', '#af4f7d', '#ae4c7b', '#ac4a79', '#ab4877', '#aa4575',
     '#a84373', '#a74071', '#a53e6f', '#a43b6d', '#a3396b', '#a13669',
     '#a03467', '#9e3165', '#9d2e63', '#9b2c61', '#9a295f', '#98265d',
     '#97245b', '#952158', '#931e56', '#921b54', '#901851', '#8e154f',
     '#8c114c', '#89114b', '#861049', '#831047', '#801046', '#7d0f44',
     '#7a0f42', '#770f41', '#740e3f', '#720e3e', '#6f0d3c', '#6c0d3a',
     '#690d39', '#660c37', '#630c36', '#600c34', '#5d0b33', '#5a0b31',
     '#580b30', '#550a2e', '#520a2c', '#4f0a2b', '#4c0929', '#490928',
     '#470926', '#440825', '#410823', '#3f0822', '#3c0721', '#39071f',
     '#37071e', '#34061c', '#31061b', '#2f0619', '#2c0518', '#290516',
     '#260514', '#220412', '#1e0410', '#1a030e', '#15030b', '#0f0208',
     '#080104', '#000000']

cmasher_greens = mpl_c.LinearSegmentedColormap.from_list('cmasher_greens', cmasher_greens_list)
cmasher_greens_r = mpl_c.LinearSegmentedColormap.from_list('cmasher_greens_r', cmasher_greens_list[::-1])
cmasher_oranges = mpl_c.LinearSegmentedColormap.from_list('cmasher_oranges', cmasher_oranges_list)
cmasher_oranges_r = mpl_c.LinearSegmentedColormap.from_list('cmasher_oranges_r', cmasher_oranges_list[::-1])
cmasher_purples = mpl_c.LinearSegmentedColormap.from_list('cmasher_purples', cmasher_purples_list)
cmasher_purples_r = mpl_c.LinearSegmentedColormap.from_list('cmasher_purples_r', cmasher_purples_list[::-1])
cmasher_greens_nobezier = mpl_c.LinearSegmentedColormap.from_list('cmasher_greens_nobezier', cmasher_greens_nobezier_list)
cmasher_greens_nobezier_r = mpl_c.LinearSegmentedColormap.from_list('cmasher_greens_nobezier_r', cmasher_greens_nobezier_list[::-1])
cmasher_oranges_nobezier = mpl_c.LinearSegmentedColormap.from_list('cmasher_oranges_nobezier', cmasher_oranges_nobezier_list)
cmasher_oranges_nobezier_r = mpl_c.LinearSegmentedColormap.from_list('cmasher_oranges_nobezier_r', cmasher_oranges_nobezier_list[::-1])
cmasher_purples_nobezier = mpl_c.LinearSegmentedColormap.from_list('cmasher_purples_nobezier', cmasher_purples_nobezier_list)
cmasher_purples_nobezier_r = mpl_c.LinearSegmentedColormap.from_list('cmasher_purples_nobezier_r', cmasher_purples_nobezier_list[::-1])

atri_blues_list = \
    ['#ffffff', '#fbfdff', '#f7fbff', '#f3f9ff', '#eff7ff', '#ebf5ff',
     '#e7f3ff', '#e3f1ff', '#dfefff', '#dbedff', '#d7ebff', '#d3e9ff',
     '#cfe7ff', '#cae5ff', '#c6e3ff', '#c2e1ff', '#bedfff', '#baddff',
     '#b6dbff', '#b2d9ff', '#aed7ff', '#aad4ff', '#a5d2ff', '#a1d0ff',
     '#9dceff', '#99ccff', '#95caff', '#91c8ff', '#8cc6ff', '#88c4ff',
     '#84c2ff', '#7fbfff', '#7bbdff', '#77bbff', '#72b9ff', '#6eb7ff',
     '#6ab5ff', '#65b2ff', '#61b0ff', '#5caeff', '#58acff', '#53a9ff',
     '#4fa7ff', '#4aa5ff', '#45a2ff', '#40a0ff', '#3c9eff', '#379bff',
     '#3299ff', '#2d96ff', '#2894ff', '#2391ff', '#1e8fff', '#198cff',
     '#138aff', '#0e87ff', '#0884ff', '#0381ff', '#007ffd', '#007df9',
     '#007bf5', '#0079f2', '#0077ee', '#0075ea', '#0074e6', '#0072e2',
     '#0070de', '#006edb', '#006cd7', '#006ad3', '#0068cf', '#0066cc',
     '#0064c8', '#0063c4', '#0061c1', '#005fbd', '#005db9', '#005bb6',
     '#0059b2', '#0058ae', '#0056ab', '#0054a7', '#0052a4', '#0050a0',
     '#004f9c', '#004d99', '#004b95', '#004992', '#00478e', '#00468b',
     '#004487', '#004284', '#004181', '#003f7d', '#003d7a', '#003b76',
     '#003a73', '#003870', '#00366c', '#003569', '#003366', '#003162',
     '#00305f', '#002e5c', '#002c58', '#002b55', '#002952', '#00284f',
     '#00264c', '#002448', '#002345', '#002142', '#00203f', '#001e3c',
     '#001d39', '#001b36', '#001a33', '#001830', '#00172d', '#00152a',
     '#001326', '#001122', '#000f1e', '#000d19', '#000a14', '#00070d',
     '#000307', '#000000']
atri_purples_list = \
    ['#ffffff', '#fefcfd', '#fdfafb', '#fcf7f9', '#fbf4f7', '#faf1f5',
     '#f9eff4', '#f9ecf2', '#f8e9f0', '#f7e7ee', '#f6e4ec', '#f5e1ea',
     '#f4dee8', '#f3dce6', '#f2d9e4', '#f1d6e2', '#f0d3e0', '#efd1df',
     '#efcedd', '#eecbdb', '#edc9d9', '#ecc6d7', '#ebc3d5', '#eac0d3',
     '#e9bed1', '#e8bbcf', '#e7b8cd', '#e6b6cb', '#e5b3c9', '#e4b0c8',
     '#e3adc6', '#e3abc4', '#e2a8c2', '#e1a5c0', '#e0a2be', '#dfa0bc',
     '#de9dba', '#dd9ab8', '#dc97b6', '#db95b4', '#da92b2', '#d98fb0',
     '#d88cae', '#d789ac', '#d687aa', '#d584a8', '#d481a6', '#d47ea4',
     '#d37ba2', '#d278a0', '#d1769e', '#d0739c', '#cf709a', '#ce6d98',
     '#cd6a96', '#cc6794', '#cb6492', '#ca6190', '#c95e8e', '#c85b8c',
     '#c75889', '#c55487', '#c45185', '#c34e83', '#c24b80', '#c1487e',
     '#c0447c', '#bf4179', '#be3d77', '#bc3a74', '#bb3672', '#ba326f',
     '#b92e6d', '#b72b6a', '#b62667', '#b42264', '#b31e61', '#b1195d',
     '#b0145a', '#ae0e56', '#ac0852', '#aa034e', '#a6034c', '#a3034b',
     '#9f0349', '#9c0347', '#980346', '#950344', '#920343', '#8e0341',
     '#8b0240', '#87023e', '#84023d', '#81023b', '#7d023a', '#7a0238',
     '#770237', '#740235', '#700234', '#6d0232', '#6a0231', '#67022f',
     '#63022e', '#60022c', '#5d022b', '#5a0229', '#570228', '#540126',
     '#510125', '#4e0124', '#4b0122', '#480121', '#45011f', '#42011e',
     '#3f011d', '#3c011b', '#39011a', '#360119', '#330117', '#300116',
     '#2c0114', '#290113', '#240111', '#20010f', '#1a000c', '#140009',
     '#0b0005', '#000000']
atri_oranges_list = \
    ['#ffffff', '#fffcfa', '#fffaf4', '#fff7ef', '#fff4ea', '#fff2e4',
     '#ffefdf', '#ffecd9', '#ffead4', '#ffe7ce', '#ffe4c9', '#ffe1c3',
     '#ffdfbe', '#ffdcb8', '#ffd9b3', '#ffd6ad', '#ffd3a7', '#ffd1a2',
     '#ffce9c', '#ffcb96', '#ffc890', '#ffc58a', '#ffc285', '#ffbf7f',
     '#ffbc79', '#ffb973', '#ffb66d', '#ffb366', '#ffb060', '#ffad5a',
     '#ffaa54', '#ffa64d', '#ffa347', '#ffa040', '#ff9c39', '#ff9932',
     '#ff962c', '#ff9224', '#ff8e1d', '#ff8b16', '#ff870e', '#ff8307',
     '#ff8000', '#fb7e00', '#f87d00', '#f57b00', '#f17900', '#ee7800',
     '#eb7600', '#e87400', '#e57300', '#e27100', '#de7000', '#db6e00',
     '#d86c00', '#d56b00', '#d26900', '#cf6800', '#cb6600', '#c86500',
     '#c56300', '#c26100', '#bf6000', '#bc5e00', '#b95d00', '#b65b00',
     '#b35a00', '#b05800', '#ad5700', '#aa5500', '#a75400', '#a45200',
     '#a15100', '#9e4f00', '#9b4e00', '#984c00', '#954b00', '#924900',
     '#8f4800', '#8c4600', '#894500', '#864300', '#834200', '#804000',
     '#7d3f00', '#7b3e00', '#783c00', '#753b00', '#723900', '#6f3800',
     '#6c3600', '#6a3500', '#673400', '#643200', '#613100', '#5f2f00',
     '#5c2e00', '#592d00', '#562b00', '#542a00', '#512900', '#4e2700',
     '#4c2600', '#492500', '#462300', '#442200', '#412100', '#3f1f00',
     '#3c1e00', '#3a1d00', '#371c00', '#351a00', '#321900', '#301800',
     '#2d1700', '#2b1500', '#281400', '#261300', '#231200', '#211000',
     '#1e0f00', '#1b0d00', '#170c00', '#130a00', '#0f0700', '#0a0500',
     '#050300', '#000000']
atri_blues = mpl_c.LinearSegmentedColormap.from_list('atri_blues', atri_blues_list)
atri_blues_r = mpl_c.LinearSegmentedColormap.from_list('atri_blues_r', atri_blues_list[::-1])
atri_purples = mpl_c.LinearSegmentedColormap.from_list('atri_purples', atri_purples_list)
atri_purples_r = mpl_c.LinearSegmentedColormap.from_list('atri_purples_r', atri_purples_list[::-1])
atri_oranges = mpl_c.LinearSegmentedColormap.from_list('atri_oranges', atri_oranges_list)
atri_oranges_r = mpl_c.LinearSegmentedColormap.from_list('atri_oranges_r', atri_oranges_list[::-1])

atri_blues_40_list = \
    ['#ffffff', '#fcfdfe', '#fafafd', '#f7f8fc', '#f4f6fb', '#f1f4fa',
     '#eff1f9', '#eceff8', '#e9edf7', '#e7ebf6', '#e4e8f5', '#e1e6f4',
     '#dee4f3', '#dce2f2', '#d9dff1', '#d6ddf0', '#d4dbef', '#d1d9ee',
     '#ced6ed', '#ccd4ec', '#c9d2eb', '#c6d0ea', '#c4ceea', '#c1cbe9',
     '#bec9e8', '#bcc7e7', '#b9c5e6', '#b7c3e5', '#b4c0e4', '#b1bee3',
     '#afbce2', '#acbae1', '#a9b8e0', '#a7b5df', '#a4b3de', '#a2b1dd',
     '#9fafdc', '#9caddb', '#9aaada', '#97a8d9', '#95a6d8', '#92a4d7',
     '#8fa2d7', '#8da0d6', '#8a9ed5', '#889bd4', '#8599d3', '#8297d2',
     '#8095d1', '#7d93d0', '#7b91cf', '#788ece', '#768ccd', '#738acc',
     '#7088cb', '#6e86ca', '#6b84c9', '#6982c9', '#6780c7', '#657ec3',
     '#637cc0', '#627abd', '#6078ba', '#5f76b7', '#5d74b4', '#5c72b1',
     '#5a70ae', '#596eab', '#576ca8', '#556aa5', '#5468a2', '#52669f',
     '#51659c', '#4f6399', '#4e6196', '#4c5f94', '#4b5d91', '#495b8e',
     '#48598b', '#465788', '#455685', '#435482', '#42527f', '#40507d',
     '#3f4e7a', '#3e4c77', '#3c4b74', '#3b4971', '#39476f', '#38456c',
     '#364469', '#354266', '#334064', '#323e61', '#313c5e', '#2f3b5b',
     '#2e3959', '#2d3756', '#2b3653', '#2a3451', '#28324e', '#27314c',
     '#262f49', '#242d46', '#232c44', '#222a41', '#20283f', '#1f273c',
     '#1e253a', '#1d2337', '#1b2235', '#1a2032', '#191f30', '#171d2d',
     '#161c2b', '#151a29', '#141926', '#121724', '#111521', '#10141f',
     '#0e121c', '#0d1019', '#0b0e15', '#090b12', '#07090d', '#050609',
     '#020305', '#000000']
atri_purples_40_list = \
    ['#ffffff', '#fefcfd', '#fcfafb', '#fbf7f8', '#f9f5f6', '#f8f2f4',
     '#f6f0f2', '#f5edf0', '#f4ebed', '#f2e8eb', '#f1e6e9', '#efe3e7',
     '#eee1e5', '#eddee2', '#ebdce0', '#ead9de', '#e8d7dc', '#e7d4da',
     '#e6d2d7', '#e4cfd5', '#e3cdd3', '#e1cad1', '#e0c8cf', '#dfc5cd',
     '#ddc3ca', '#dcc0c8', '#dabec6', '#d9bbc4', '#d8b9c2', '#d6b7c0',
     '#d5b4be', '#d3b2bb', '#d2afb9', '#d1adb7', '#cfaab5', '#cea8b3',
     '#cda5b1', '#cba3af', '#caa1ac', '#c89eaa', '#c79ca8', '#c699a6',
     '#c497a4', '#c394a2', '#c292a0', '#c0909e', '#bf8d9b', '#be8b99',
     '#bc8897', '#bb8695', '#b98393', '#b88191', '#b77f8f', '#b57c8d',
     '#b47a8a', '#b37788', '#b17586', '#b07284', '#af7082', '#ad6e80',
     '#ac6b7e', '#aa697c', '#a9667a', '#a86477', '#a66275', '#a55f73',
     '#a45d71', '#a25a6f', '#a1586d', '#9f556b', '#9e5368', '#9d5066',
     '#9b4e64', '#9a4b62', '#994960', '#97465e', '#96445b', '#944159',
     '#933f57', '#913c55', '#903a52', '#8e3750', '#8b364f', '#88354d',
     '#85344b', '#823349', '#7f3148', '#7c3046', '#792f44', '#762e43',
     '#732d41', '#702c3f', '#6d2a3e', '#6a293c', '#67283a', '#642739',
     '#622637', '#5f2535', '#5c2434', '#592332', '#562131', '#53202f',
     '#501f2d', '#4e1e2c', '#4b1d2a', '#481c29', '#451b27', '#431a26',
     '#401924', '#3d1823', '#3b1721', '#38161f', '#35151e', '#33141d',
     '#30131b', '#2d121a', '#2b1118', '#281017', '#250f15', '#230d13',
     '#200c12', '#1c0b10', '#18090e', '#14080b', '#100609', '#0b0406',
     '#050203', '#000000']
atri_oranges_40_list = \
    ['#ffffff', '#fefcfb', '#fdfaf8', '#fcf7f4', '#fbf5f0', '#faf2ed',
     '#f9f0e9', '#f8ede5', '#f8ebe2', '#f7e8de', '#f6e6da', '#f5e3d7',
     '#f4e1d3', '#f3decf', '#f2dbcc', '#f1d9c8', '#f0d6c4', '#efd4c1',
     '#eed1bd', '#edcfb9', '#ecccb6', '#ebcab2', '#ebc7ae', '#eac5ab',
     '#e9c2a7', '#e8c0a3', '#e7bda0', '#e6ba9c', '#e5b898', '#e4b595',
     '#e3b391', '#e2b08d', '#e1ae89', '#e0ab86', '#dfa882', '#dea67e',
     '#dda37b', '#dca177', '#db9e73', '#db9b6f', '#da996c', '#d99668',
     '#d79464', '#d59263', '#d29062', '#cf8e61', '#cc8c5f', '#ca8a5e',
     '#c7885d', '#c4875b', '#c1855a', '#bf8359', '#bc8158', '#b97f56',
     '#b77d55', '#b47b54', '#b17a53', '#af7851', '#ac7650', '#a9744f',
     '#a7724e', '#a4704c', '#a16f4b', '#9f6d4a', '#9c6b49', '#9a6948',
     '#976846', '#946645', '#926444', '#8f6243', '#8d6042', '#8a5f40',
     '#875d3f', '#855b3e', '#82593d', '#80583c', '#7d563a', '#7b5439',
     '#785338', '#765137', '#734f36', '#714d35', '#6e4c33', '#6c4a32',
     '#694831', '#674730', '#65452f', '#62432e', '#60422d', '#5d402c',
     '#5b3e2a', '#593d29', '#563b28', '#543a27', '#523826', '#4f3625',
     '#4d3524', '#4b3323', '#483222', '#463021', '#442e20', '#412d1f',
     '#3f2b1d', '#3d2a1c', '#3b281b', '#39271a', '#362519', '#342418',
     '#322217', '#302116', '#2e1f15', '#2c1e14', '#291c13', '#271b12',
     '#251a11', '#231810', '#21170f', '#1f150e', '#1d140d', '#1b120c',
     '#18110b', '#160f0a', '#130d09', '#0f0b07', '#0c0805', '#080504',
     '#040302', '#000000']
atri_blues_40 = mpl_c.LinearSegmentedColormap.from_list('atri_blues_40', atri_blues_40_list)
atri_blues_40_r = mpl_c.LinearSegmentedColormap.from_list('atri_blues_40_r', atri_blues_40_list[::-1])
atri_purples_40 = mpl_c.LinearSegmentedColormap.from_list('atri_purples_40', atri_purples_40_list)
atri_purples_40_r = mpl_c.LinearSegmentedColormap.from_list('atri_purples_40_r', atri_purples_40_list[::-1])
atri_oranges_40 = mpl_c.LinearSegmentedColormap.from_list('atri_oranges_40', atri_oranges_40_list)
atri_oranges_40_r = mpl_c.LinearSegmentedColormap.from_list('atri_oranges_40_r', atri_oranges_40_list[::-1])

dmk_ck_list = \
[[0.97647059, 0.97254902, 0.03921569, 1.        ],
 [0.98039216, 0.96078431, 0.04313725, 1.        ],
 [0.98039216, 0.95294118, 0.04705882, 1.        ],
 [0.98431373, 0.94509804, 0.04705882, 1.        ],
 [0.98823529, 0.93333333, 0.05098039, 1.        ],
 [0.99215686, 0.9254902 , 0.05490196, 1.        ],
 [0.99215686, 0.91372549, 0.05490196, 1.        ],
 [0.99607843, 0.90588235, 0.05882353, 1.        ],
 [0.99607843, 0.89411765, 0.05882353, 1.        ],
 [0.99607843, 0.88627451, 0.0627451 , 1.        ],
 [0.99607843, 0.87843137, 0.0627451 , 1.        ],
 [1.        , 0.86666667, 0.06666667, 1.        ],
 [1.        , 0.85882353, 0.06666667, 1.        ],
 [1.        , 0.85098039, 0.07058824, 1.        ],
 [1.        , 0.83921569, 0.07058824, 1.        ],
 [0.99607843, 0.83137255, 0.07058824, 1.        ],
 [0.99607843, 0.82352941, 0.0745098 , 1.        ],
 [0.99607843, 0.81568627, 0.0745098 , 1.        ],
 [0.99215686, 0.80392157, 0.0745098 , 1.        ],
 [0.99215686, 0.79607843, 0.0745098 , 1.        ],
 [0.98823529, 0.78823529, 0.07843137, 1.        ],
 [0.98431373, 0.78039216, 0.07843137, 1.        ],
 [0.98039216, 0.77254902, 0.07843137, 1.        ],
 [0.97647059, 0.76470588, 0.07843137, 1.        ],
 [0.96862745, 0.75686275, 0.07843137, 1.        ],
 [0.96470588, 0.75294118, 0.07843137, 1.        ],
 [0.95686275, 0.74509804, 0.07843137, 1.        ],
 [0.94901961, 0.7372549 , 0.07843137, 1.        ],
 [0.94117647, 0.73333333, 0.07843137, 1.        ],
 [0.92941176, 0.72941176, 0.07843137, 1.        ],
 [0.91764706, 0.72156863, 0.07843137, 1.        ],
 [0.90588235, 0.71764706, 0.0745098 , 1.        ],
 [0.89411765, 0.71372549, 0.0745098 , 1.        ],
 [0.87843137, 0.71372549, 0.0745098 , 1.        ],
 [0.85882353, 0.70980392, 0.07058824, 1.        ],
 [0.83921569, 0.70980392, 0.07058824, 1.        ],
 [0.81960784, 0.70980392, 0.0745098 , 1.        ],
 [0.79607843, 0.70588235, 0.08235294, 1.        ],
 [0.77647059, 0.70588235, 0.09411765, 1.        ],
 [0.75686275, 0.70196078, 0.10588235, 1.        ],
 [0.7372549 , 0.70196078, 0.11764706, 1.        ],
 [0.71764706, 0.69803922, 0.12941176, 1.        ],
 [0.69803922, 0.69803922, 0.14509804, 1.        ],
 [0.67843137, 0.69411765, 0.15686275, 1.        ],
 [0.65882353, 0.69019608, 0.17254902, 1.        ],
 [0.63921569, 0.68627451, 0.18431373, 1.        ],
 [0.61960784, 0.68235294, 0.2       , 1.        ],
 [0.6       , 0.68235294, 0.21568627, 1.        ],
 [0.58431373, 0.67843137, 0.23137255, 1.        ],
 [0.56470588, 0.6745098 , 0.24313725, 1.        ],
 [0.54117647, 0.67058824, 0.25882353, 1.        ],
 [0.52156863, 0.66666667, 0.2745098 , 1.        ],
 [0.50196078, 0.6627451 , 0.28627451, 1.        ],
 [0.48235294, 0.65882353, 0.30196078, 1.        ],
 [0.45882353, 0.65490196, 0.31764706, 1.        ],
 [0.43921569, 0.65098039, 0.33333333, 1.        ],
 [0.41568627, 0.64705882, 0.34509804, 1.        ],
 [0.39215686, 0.63921569, 0.36078431, 1.        ],
 [0.36862745, 0.63529412, 0.37647059, 1.        ],
 [0.34901961, 0.63137255, 0.39215686, 1.        ],
 [0.32941176, 0.62352941, 0.40784314, 1.        ],
 [0.30980392, 0.61960784, 0.41960784, 1.        ],
 [0.29019608, 0.61568627, 0.43529412, 1.        ],
 [0.27058824, 0.60784314, 0.45098039, 1.        ],
 [0.25098039, 0.6       , 0.46666667, 1.        ],
 [0.23529412, 0.59607843, 0.47843137, 1.        ],
 [0.21960784, 0.58823529, 0.49411765, 1.        ],
 [0.20392157, 0.58431373, 0.50980392, 1.        ],
 [0.18823529, 0.57647059, 0.5254902 , 1.        ],
 [0.17647059, 0.56862745, 0.54117647, 1.        ],
 [0.16470588, 0.56078431, 0.55686275, 1.        ],
 [0.15294118, 0.55294118, 0.57254902, 1.        ],
 [0.14509804, 0.54509804, 0.58823529, 1.        ],
 [0.14117647, 0.5372549 , 0.60392157, 1.        ],
 [0.13333333, 0.5254902 , 0.61960784, 1.        ],
 [0.13333333, 0.51764706, 0.63529412, 1.        ],
 [0.13333333, 0.50588235, 0.65490196, 1.        ],
 [0.1372549 , 0.49803922, 0.67058824, 1.        ],
 [0.14117647, 0.48627451, 0.68627451, 1.        ],
 [0.14901961, 0.4745098 , 0.70588235, 1.        ],
 [0.16078431, 0.4627451 , 0.72156863, 1.        ],
 [0.17254902, 0.45098039, 0.7372549 , 1.        ],
 [0.18039216, 0.43921569, 0.75294118, 1.        ],
 [0.18823529, 0.42745098, 0.76470588, 1.        ],
 [0.19607843, 0.41568627, 0.77254902, 1.        ],
 [0.20392157, 0.40784314, 0.78039216, 1.        ],
 [0.20784314, 0.39607843, 0.78431373, 1.        ],
 [0.21176471, 0.38823529, 0.78823529, 1.        ],
 [0.21568627, 0.38039216, 0.78823529, 1.        ],
 [0.22352941, 0.36862745, 0.78431373, 1.        ],
 [0.22745098, 0.36078431, 0.78431373, 1.        ],
 [0.22745098, 0.35294118, 0.77647059, 1.        ],
 [0.23137255, 0.34509804, 0.77254902, 1.        ],
 [0.23529412, 0.3372549 , 0.76470588, 1.        ],
 [0.23921569, 0.32941176, 0.75686275, 1.        ],
 [0.24313725, 0.3254902 , 0.74901961, 1.        ],
 [0.24705882, 0.31764706, 0.7372549 , 1.        ],
 [0.24705882, 0.30980392, 0.72941176, 1.        ],
 [0.25098039, 0.30588235, 0.71764706, 1.        ],
 [0.25490196, 0.29803922, 0.70588235, 1.        ],
 [0.25490196, 0.29411765, 0.69411765, 1.        ],
 [0.25882353, 0.28627451, 0.67843137, 1.        ],
 [0.25882353, 0.28235294, 0.66666667, 1.        ],
 [0.25882353, 0.27843137, 0.65098039, 1.        ],
 [0.2627451 , 0.27058824, 0.63529412, 1.        ],
 [0.2627451 , 0.26666667, 0.62352941, 1.        ],
 [0.2627451 , 0.2627451 , 0.60784314, 1.        ],
 [0.2627451 , 0.25882353, 0.58823529, 1.        ],
 [0.2627451 , 0.25490196, 0.57254902, 1.        ],
 [0.2627451 , 0.25098039, 0.55686275, 1.        ],
 [0.2627451 , 0.24705882, 0.54117647, 1.        ],
 [0.2627451 , 0.24313725, 0.52156863, 1.        ],
 [0.25882353, 0.23921569, 0.50196078, 1.        ],
 [0.25882353, 0.23529412, 0.48627451, 1.        ],
 [0.25490196, 0.23137255, 0.46666667, 1.        ],
 [0.25490196, 0.22745098, 0.44705882, 1.        ],
 [0.25098039, 0.22352941, 0.42745098, 1.        ],
 [0.24705882, 0.21960784, 0.41176471, 1.        ],
 [0.24313725, 0.21568627, 0.39215686, 1.        ],
 [0.23921569, 0.21568627, 0.37254902, 1.        ],
 [0.23529412, 0.21176471, 0.35294118, 1.        ],
 [0.23137255, 0.20784314, 0.33333333, 1.        ],
 [0.22745098, 0.20392157, 0.31372549, 1.        ],
 [0.22352941, 0.20392157, 0.29411765, 1.        ],
 [0.21568627, 0.2       , 0.2745098 , 1.        ],
 [0.21176471, 0.19607843, 0.25490196, 1.        ],
 [0.20392157, 0.19607843, 0.23529412, 1.        ],
 [0.19607843, 0.19215686, 0.21176471, 1.        ],
 [0.18823529, 0.18823529, 0.19215686, 1.        ]]
dmk_ck = mpl_c.LinearSegmentedColormap.from_list('dmk_ck', dmk_ck_list)
dmk_ck_r = mpl_c.LinearSegmentedColormap.from_list('dmk_ck_r', dmk_ck_list[::-1])

arpes_list = \
      [[0.50980392, 0.        , 0.        , 1.        ],
       [0.5372549 , 0.        , 0.        , 1.        ],
       [0.56862745, 0.        , 0.        , 1.        ],
       [0.6       , 0.        , 0.        , 1.        ],
       [0.63137255, 0.        , 0.        , 1.        ],
       [0.6627451 , 0.        , 0.        , 1.        ],
       [0.69411765, 0.        , 0.        , 1.        ],
       [0.7254902 , 0.        , 0.        , 1.        ],
       [0.75686275, 0.        , 0.        , 1.        ],
       [0.78431373, 0.        , 0.        , 1.        ],
       [0.81960784, 0.        , 0.        , 1.        ],
       [0.84705882, 0.        , 0.        , 1.        ],
       [0.87843137, 0.        , 0.        , 1.        ],
       [0.90980392, 0.        , 0.        , 1.        ],
       [0.94117647, 0.        , 0.        , 1.        ],
       [0.97254902, 0.        , 0.        , 1.        ],
       [0.99607843, 0.00784314, 0.        , 1.        ],
       [1.        , 0.03529412, 0.        , 1.        ],
       [1.        , 0.06666667, 0.        , 1.        ],
       [1.        , 0.09803922, 0.        , 1.        ],
       [1.        , 0.12941176, 0.        , 1.        ],
       [1.        , 0.16078431, 0.        , 1.        ],
       [1.        , 0.19215686, 0.        , 1.        ],
       [1.        , 0.21960784, 0.        , 1.        ],
       [1.        , 0.25098039, 0.        , 1.        ],
       [1.        , 0.28627451, 0.        , 1.        ],
       [1.        , 0.31372549, 0.        , 1.        ],
       [1.        , 0.34509804, 0.        , 1.        ],
       [1.        , 0.37647059, 0.        , 1.        ],
       [1.        , 0.40784314, 0.        , 1.        ],
       [1.        , 0.43921569, 0.        , 1.        ],
       [1.        , 0.47058824, 0.        , 1.        ],
       [1.        , 0.50196078, 0.        , 1.        ],
       [1.        , 0.52941176, 0.        , 1.        ],
       [1.        , 0.56078431, 0.        , 1.        ],
       [1.        , 0.59215686, 0.        , 1.        ],
       [1.        , 0.61960784, 0.        , 1.        ],
       [1.        , 0.65098039, 0.        , 1.        ],
       [1.        , 0.68235294, 0.        , 1.        ],
       [1.        , 0.71372549, 0.        , 1.        ],
       [1.        , 0.74509804, 0.        , 1.        ],
       [1.        , 0.77647059, 0.        , 1.        ],
       [1.        , 0.80784314, 0.        , 1.        ],
       [1.        , 0.83921569, 0.        , 1.        ],
       [1.        , 0.87058824, 0.        , 1.        ],
       [1.        , 0.89803922, 0.        , 1.        ],
       [1.        , 0.93333333, 0.        , 1.        ],
       [1.        , 0.96078431, 0.        , 1.        ],
       [1.        , 0.99215686, 0.        , 1.        ],
       [0.97647059, 0.98039216, 0.00784314, 1.        ],
       [0.94901961, 0.95686275, 0.01960784, 1.        ],
       [0.9254902 , 0.93333333, 0.03137255, 1.        ],
       [0.89803922, 0.90588235, 0.04313725, 1.        ],
       [0.8745098 , 0.88235294, 0.05490196, 1.        ],
       [0.84705882, 0.85882353, 0.06666667, 1.        ],
       [0.81960784, 0.83529412, 0.07843137, 1.        ],
       [0.79607843, 0.81568627, 0.09019608, 1.        ],
       [0.76862745, 0.78823529, 0.10196078, 1.        ],
       [0.74117647, 0.76470588, 0.11372549, 1.        ],
       [0.71764706, 0.74117647, 0.1254902 , 1.        ],
       [0.69019608, 0.71764706, 0.1372549 , 1.        ],
       [0.6627451 , 0.69411765, 0.14901961, 1.        ],
       [0.63529412, 0.67058824, 0.16078431, 1.        ],
       [0.61176471, 0.64705882, 0.17254902, 1.        ],
       [0.58431373, 0.61960784, 0.18431373, 1.        ],
       [0.56078431, 0.59607843, 0.19215686, 1.        ],
       [0.52941176, 0.57254902, 0.20392157, 1.        ],
       [0.50588235, 0.54901961, 0.21568627, 1.        ],
       [0.47843137, 0.5254902 , 0.22745098, 1.        ],
       [0.45490196, 0.50196078, 0.23921569, 1.        ],
       [0.42745098, 0.47843137, 0.25098039, 1.        ],
       [0.40392157, 0.45490196, 0.2627451 , 1.        ],
       [0.37254902, 0.42745098, 0.2745098 , 1.        ],
       [0.34901961, 0.40392157, 0.28627451, 1.        ],
       [0.32156863, 0.38039216, 0.29803922, 1.        ],
       [0.29803922, 0.36078431, 0.30980392, 1.        ],
       [0.27058824, 0.3372549 , 0.32156863, 1.        ],
       [0.24313725, 0.30980392, 0.33333333, 1.        ],
       [0.21960784, 0.28627451, 0.34509804, 1.        ],
       [0.19215686, 0.2627451 , 0.35686275, 1.        ],
       [0.16470588, 0.23921569, 0.36862745, 1.        ],
       [0.16078431, 0.23529412, 0.38039216, 1.        ],
       [0.17254902, 0.24705882, 0.39215686, 1.        ],
       [0.18823529, 0.2627451 , 0.40392157, 1.        ],
       [0.2       , 0.2745098 , 0.41568627, 1.        ],
       [0.21568627, 0.29019608, 0.42745098, 1.        ],
       [0.22745098, 0.30196078, 0.44313725, 1.        ],
       [0.24313725, 0.31764706, 0.45490196, 1.        ],
       [0.25490196, 0.32941176, 0.46666667, 1.        ],
       [0.27058824, 0.34509804, 0.47843137, 1.        ],
       [0.28235294, 0.35686275, 0.49019608, 1.        ],
       [0.29411765, 0.36862745, 0.50196078, 1.        ],
       [0.30980392, 0.38431373, 0.51372549, 1.        ],
       [0.32156863, 0.39607843, 0.52941176, 1.        ],
       [0.33333333, 0.40784314, 0.54117647, 1.        ],
       [0.34901961, 0.42352941, 0.55294118, 1.        ],
       [0.36470588, 0.43921569, 0.56470588, 1.        ],
       [0.37647059, 0.45098039, 0.57647059, 1.        ],
       [0.38823529, 0.4627451 , 0.58823529, 1.        ],
       [0.40392157, 0.47843137, 0.60392157, 1.        ],
       [0.41568627, 0.49019608, 0.61568627, 1.        ],
       [0.43137255, 0.50588235, 0.62745098, 1.        ],
       [0.44313725, 0.51764706, 0.63921569, 1.        ],
       [0.45882353, 0.53333333, 0.65098039, 1.        ],
       [0.47058824, 0.54509804, 0.66666667, 1.        ],
       [0.48627451, 0.56078431, 0.6745098 , 1.        ],
       [0.49803922, 0.57254902, 0.69019608, 1.        ],
       [0.51372549, 0.58823529, 0.70196078, 1.        ],
       [0.5254902 , 0.6       , 0.71372549, 1.        ],
       [0.54117647, 0.61568627, 0.7254902 , 1.        ],
       [0.55294118, 0.62745098, 0.7372549 , 1.        ],
       [0.56862745, 0.64313725, 0.75294118, 1.        ],
       [0.58039216, 0.65490196, 0.76470588, 1.        ],
       [0.59607843, 0.67058824, 0.77647059, 1.        ],
       [0.60784314, 0.68235294, 0.78823529, 1.        ],
       [0.62352941, 0.69803922, 0.8       , 1.        ],
       [0.63529412, 0.70980392, 0.81568627, 1.        ],
       [0.65098039, 0.7254902 , 0.82745098, 1.        ],
       [0.6627451 , 0.7372549 , 0.83921569, 1.        ],
       [0.67843137, 0.74901961, 0.85098039, 1.        ],
       [0.69019608, 0.76470588, 0.8627451 , 1.        ],
       [0.70196078, 0.77647059, 0.8745098 , 1.        ],
       [0.71764706, 0.79215686, 0.89019608, 1.        ],
       [0.72941176, 0.80392157, 0.89803922, 1.        ],
       [0.74509804, 0.81960784, 0.91372549, 1.        ],
       [0.75686275, 0.83137255, 0.9254902 , 1.        ],
       [0.76862745, 0.84313725, 0.9372549 , 1.        ],
       [0.78431373, 0.85882353, 0.94901961, 1.        ],
       [0.79607843, 0.87058824, 0.96078431, 1.        ]]
arpes = mpl_c.LinearSegmentedColormap.from_list('arpes', arpes_list)
arpes_r = mpl_c.LinearSegmentedColormap.from_list('arpes_r', arpes_list[::-1])

thermal_list = \
['#000052', '#010353', '#010654', '#020955', '#030b56', '#030e57', '#041158',
 '#041358', '#051659', '#05185a', '#061a5b', '#061c5c', '#071f5c', '#07215d',
 '#08235e', '#08255f', '#09275f', '#092960', '#0a2c61', '#0a2e61', '#0b3062',
 '#0b3263', '#0b3464', '#0c3664', '#0c3865', '#0d3a66', '#143c65', '#1f3d62',
 '#283e61', '#303f5f', '#37405e', '#3e415c', '#44425b', '#4b425a', '#504359',
 '#564458', '#5b4457', '#604556', '#654555', '#6a4654', '#6f4753', '#744752',
 '#784851', '#7d4850', '#81494f', '#86494e', '#8a4a4e', '#8f4a4d', '#934b4c',
 '#974b4b', '#9c4c4a', '#a04c49', '#a44d49', '#a84d48', '#ac4e47', '#b14e46',
 '#b54f45', '#b94f44', '#bd5044', '#c15043', '#c55142', '#c95141', '#cd5241',
 '#d15240', '#d5533f', '#d9533e', '#dd543d', '#e1543d', '#e5553c', '#e9553b',
 '#ed563a', '#f1563a', '#f55739', '#f95738', '#f85d3a', '#f7623b', '#f6673d',
 '#f56c3e', '#f47140', '#f47541', '#f37a42', '#f27e44', '#f28245', '#f18646',
 '#f08a47', '#f08d48', '#ef9149', '#ee954b', '#ee984c', '#ee9b4d', '#ef9e4d',
 '#efa14e', '#efa44f', '#f0a750', '#f0aa51', '#f0ad52', '#f1b053', '#f1b354',
 '#f1b555', '#f1b856', '#f2bb57', '#f2be57', '#f2c158', '#f2c459', '#f3c75a',
 '#f3c95b', '#f3cc5c', '#f4cf5d', '#f4d25e', '#f4d463', '#f5d76c', '#f5d975',
 '#f6db7e', '#f6de86', '#f7e08f', '#f7e297', '#f8e5a0', '#f8e7a8', '#f9e9b0',
 '#f9ebb9', '#f9edc1', '#faf0c9', '#fbf2cb', '#fcf5cd', '#fcf7ce', '#fdfacf',
 '#fefcd1', '#ffffd2']
thermal = mpl_c.LinearSegmentedColormap.from_list('thermal', thermal_list)
thermal_r = mpl_c.LinearSegmentedColormap.from_list('thermal_r', thermal_list[::-1])

def invert_lightness( colors ):
    shape = colors.shape
    C = colors.reshape((-1,shape[-1]))
    R = np.copy(C[:,0])
    G = np.copy(C[:,1])
    B = np.copy(C[:,2])
    A = np.copy(C[:,3])
    final = [1.-0.5*(G+B), 1.-0.5*(R+B), 1.-0.5*(R+G), A]
    return np.array(final).T.reshape(shape)

def stretch_center( cmap, fac, use_hyper=False, inv_l=False, endpoint=1.0 ):
    funs = (np.arctan, np.tan)
    if use_hyper:
        funs = (np.tanh, np.arctanh)
    xm = funs[0](fac)
    ary = (funs[1]( np.linspace(-xm*endpoint, xm*endpoint, 1024) ) + fac)/(2*fac)
    colors = cmap(ary)
    if inv_l:
        colors = invert_lightness(colors)
    return mpl_c.LinearSegmentedColormap.from_list( 'CmapCustom', colors )

def cut_cmap( cmap, start=0.0, end=1.0, invert=False ):
    x = np.linspace(start, end, 1024)
    if invert:
        x = x[::-1]
    colors = cmap(x)
    return mpl_c.LinearSegmentedColormap.from_list( 'CmapCustom', colors )

def export_gpl( cmap, file, num=128 ):
    x = np.linspace(0,1,num)
    colors = cmap(x)
    with open(file, "w") as f:
        f.write("GIMP Palette\n")
        f.write("Name: %s-%i\n" % (cmap.name, num))
        f.write("# created by fancymaps\n")
        for i, c in enumerate(colors):
            ch = mpl_c.to_hex(c)
            cr, cg, cb = int(ch[1:3],16), int(ch[3:5],16), int(ch[5:7],16)
            f.write( '%i %i %i %s-%i\n' % (cr,cg,cb,cmap.name,i) )

def export_tex( cmap, file, num=128 ):
    x = np.linspace(0,1,num)
    colors = cmap(x)
    with open(file, "w") as f:
        f.write("%% LaTeX Palette %s-%i\n" % (cmap.name, num))
        f.write("% requires \\usepackage{xcolor}\n")
        f.write("% created by fancymaps\n")
        for i, c in enumerate(colors):
            f.write('\\definecolor{%s-%i}{HTML}{%s}\n' % (cmap.name,i,mpl_c.to_hex(c)[1:]))

def complex_cmap_factory( periodic_cmap ):
    def complex_cmap( ary, cpow=1.0, absmax=None ):
        a = ary.flatten()
        a_abs = np.abs(a)
        a_phi = np.angle(a) / (2.*np.pi) + 0.5
        C = periodic_cmap(a_phi)
        amx = absmax if not absmax is None else a_abs.max()
        C[:,-1] *= (a_abs/amx) ** cpow
        return C.reshape((*ary.shape, 4))
    return complex_cmap

if __name__ == '__main__':
    import matplotlib.pyplot as plt
    import scipy.special as scs
    im = np.linspace(0,1,100)[None,:]
    plt.imshow( im, aspect='auto', cmap=wdiv2 )

    for map in [bdiv0, bdiv1, bdiv2]:
        x = np.linspace(-1,1,256)
        x, y = np.meshgrid(x,x)

        r = x**2+y**2

        z = scs.jv(3, 30*np.sqrt(r))
        fig = plt.figure( figsize=(9,9) )
        ax = fig.add_axes( [0,0,1,1] )
        ax.imshow(z, cmap=map, aspect='auto', interpolation='bicubic')
        ax.text( 0.5, 0.99, map.name, transform=ax.transAxes, ha='center', va='top', c='white' )
        ax.set_axis_off()

    # fig.savefig('image.jpg', dpi=400)
    plt.show()

